import $ from 'jquery';
//import './promise'

const List = (($) => {
    const NAME = 'list';
    const DATA_KEY = 'fuc.list';
    const EVENT_KEY = `.${DATA_KEY}`;
    const DATA_API_KEY = '.data-api';
    const JQUERY_NO_CONFLICT = $.fn[NAME];
    const REQUEST_LIMIT = 10;
    const DATA_TYPE = {
        OBJECT: '[object Object]',
        STRING: '[object String]',
        NUMBER: '[object Number]'
    }
    const ClassName = {
        ListGroup: 'fuc-list',
        ListLoadMore: 'fuc-list-loadmore'
    };

    const Selector = {
        ListGroup: '.fuc-list',
        ListLoadMore: '.fuc-list-loadmore',
        ListEdit: '.fuc-list-btn-edit'
    };

    const Event = {
        CLICK_DATA_API: 'click',
    };

    const LoadState = {
        LOADING: '加载中',
        LOADED: '没有更多了',
        LOAD: '加载更多'
    }

    //类型检测
    const isDataType = (data, type) => {
        return Object.prototype.toString.call(data) === type
    }

    const templete = (text) => {
        return `<li class="fuc-list-item">
                       <span class="fuc-list-eidts">${text}</span>
                       <input class="fuc-list-ipt"/>
                       <a class="fuc-list-btn-rig">操作</a>
                 </li>`
    }
    /**
     *[loadData]
     * @param {url, data}
     * @return {promise} [resolve 传递结果]
     *
     */

    const loadData = ({
            url,
            type = 'post',
            async = true,
            data = {},
            cache = false,
            dataType = 'text/plain',
            timeout = 10000,
            limit = 5
        }) => {
        return new Promise((resolve, reject) => {
            if (!url || !isDataType(url, DATA_TYPE.STRING)) {
                return reject(new Error('请输入正确的url'))
            }
            resolve(['阿道夫', '奋斗故事', '阿道夫感动'])
            // $.ajax({
            //     url,
            //     type,
            //     async,
            //     data,
            //     limit,
            //     cache,
            //     dataType,
            //     success: resolve,
            //     timeout,
            //     error: reject
            // })
        })

    }


    /**
     * @param
     * @return
     */
    const loading = (state, $ele) => {
        if (!isDataType($ele, DATA_TYPE.OBJECT)) return;
        switch (state) {
            case 'LOADING':
                return $ele.text(LoadState.LOADING)
                break
            case 'LOADED':
                return $ele.text(LoadState.LOADED)
                break
            case 'LOAD':
                return $ele.text(LoadState.LOAD)
                break
            default:
                return $ele.text(LoadState.LOAD)
        }
    }


    /**
     * class List
     * @param element [触发元素]
     * @return
     */
    class List {
        constructor(element) {
            this._element = element;
        }

        // 加载更多
        loadmore(param, cb) {
            const $ele = $(this._element)
            const {limit = REQUEST_LIMIT} = param;
            //添加list节点
            const renderList = res => $ele.before(
                    res.filter((e, idx) => idx < limit)
                        .map(e => templete(e)))
            if (!isDataType(parseInt(limit), DATA_TYPE.NUMBER)) {
                return new Error('请输入正确的请求限制数')
            }

            $ele[Event.CLICK_DATA_API](() => {
                loading('LOADING', $ele)
                loadData(param)
                    .then(res =>
                        renderList(res) &&
                        loading('LOAD', $ele) &&
                        cb &&
                        cb(res))
                    .catch( e => console.log(e))
            })

        }

        //编辑菜单
        editList() {
            const $ele = $(this._element)
            $ele[Event.CLICK_DATA_API](() => {
                console.log('editList')
            })

        }

        // Static
        static _jQueryInterface(config, param, cb) {
            return this.each(function () {
                let list = $(this).data(DATA_KEY);
                if (!list) {
                    list = new List(this, config);
                    $(this).data(DATA_KEY, list);
                }
                if (config === 'loadmore') {
                    list[config](param, cb)
                } else if (config === 'editList') {
                    list[config]()
                }
            });
        }
    }

    /**
     * ------------------------------------------------------------------------
     * jQuery
     * ------------------------------------------------------------------------
     */

    $.fn[NAME] = List._jQueryInterface;
    $.fn[NAME].Constructor = List;
    $.fn[NAME].noConflict = function () {
        $.fn[NAME] = JQUERY_NO_CONFLICT;
        return List._jQueryInterface;
    };

    return List;
})($)
export default List
