/*!
 * Fintech UI Components for the web
 * Version 0.2.3
 * Copyright © 2017-2018 JD Finance Inc.
 * License: MIT (https://github.com/joy-web/fuc.js/blob/master/LICENSE)
*/
(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('jquery')) :
  typeof define === 'function' && define.amd ? define(['exports', 'jquery'], factory) :
  (factory((global.fuc = {}),global.jQuery));
}(this, (function (exports,$) { 'use strict';

  $ = $ && $.hasOwnProperty('default') ? $['default'] : $;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
  // import 'jquery-validation';

  var Form = function ($$$1) {
    var NAME = 'form';
    var DATA_KEY = 'fuc.form';
    var EVENT_KEY = '.' + DATA_KEY;
    var DATA_API_KEY = '.data-api';
    var JQUERY_NO_CONFLICT = $$$1.fn[NAME];

    var ClassName = {
      active: 'active',
      FORM: 'fuc-form'
    };

    var Selector = {
      DATA_TOGGLE_CARROT: '[data-toggle^="form"]',
      FORM: '.fuc-form'
    };

    var Event = {
      CLICK_DATA_API: 'click' + EVENT_KEY + DATA_API_KEY
    };

    var Form = function () {
      function Form(element) {
        _classCallCheck(this, Form);

        this._element = element;
      }

      // Public


      Form.prototype.active = function active() {
        $$$1(this._element).addClass(ClassName.active);
      };

      // Static


      Form._jQueryInterface = function _jQueryInterface(config) {
        return this.each(function () {
          var data = $$$1(this).data(DATA_KEY);

          if (!data) {
            data = new Form(this, config);
            $$$1(this).data(DATA_KEY, data);
          }

          if (config === 'active') {
            data[config]();
          }
        });
      };

      return Form;
    }();

    /**
     * ------------------------------------------------------------------------
     * Data Api implementation
     * ------------------------------------------------------------------------
     */

    $$$1(document).on(Event.CLICK_DATA_API, Selector.DATA_TOGGLE_CARROT, function (event) {
      event.preventDefault();

      var form = event.target;

      if (!$$$1(form).hasClass(ClassName.FORM)) {
        form = $$$1(form).closest(Selector.FORM);
      }

      Form._jQueryInterface.call($$$1(form), 'toggle');
    });

    /**
     * ------------------------------------------------------------------------
     * jQuery
     * ------------------------------------------------------------------------
     */

    $$$1.fn[NAME] = Form._jQueryInterface;
    $$$1.fn[NAME].Constructor = Form;
    $$$1.fn[NAME].noConflict = function () {
      $$$1.fn[NAME] = JQUERY_NO_CONFLICT;
      return Form._jQueryInterface;
    };

    return Form;
  }($);

  var availablePrefixs = ['moz', 'ms', 'webkit'];

  function requestAnimationFramePolyfill() {
    var lastTime = 0;
    return function (callback) {
      var currTime = new Date().getTime();
      var timeToCall = Math.max(0, 16 - (currTime - lastTime));
      var id = window.setTimeout(function () {
        callback(currTime + timeToCall);
      }, timeToCall);
      lastTime = currTime + timeToCall;
      return id;
    };
  }

  function getRequestAnimationFrame() {
    if (typeof window === 'undefined') {
      return function () {};
    }
    if (window.requestAnimationFrame) {
      // https://github.com/vuejs/vue/issues/4465
      return window.requestAnimationFrame.bind(window);
    }

    var prefix = availablePrefixs.filter(function (key) {
      return key + 'RequestAnimationFrame' in window;
    })[0];

    return prefix ? window[prefix + 'RequestAnimationFrame'] : requestAnimationFramePolyfill();
  }

  function easeInOutCubic(t, b, c, d) {
    var cc = c - b;
    t /= d / 2;
    if (t < 1) {
      return cc / 2 * t * t * t + b;
    }
    return cc / 2 * ((t -= 2) * t * t + 2) + b;
  }

  function _classCallCheck$1(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  var reqAnimFrame = getRequestAnimationFrame();

  function noop() {}

  function getScroll(target, top) {
    if (typeof window === 'undefined') {
      return 0;
    }

    var prop = top ? 'pageYOffset' : 'pageXOffset';
    var method = top ? 'scrollTop' : 'scrollLeft';
    var isWindow = target === window;

    var ret = isWindow ? target[prop] : target[method];
    // ie6,7,8 standard mode
    if (isWindow && typeof ret !== 'number') {
      ret = window.document.documentElement[method];
    }

    return ret;
  }

  var BackTop = function ($$$1) {

    var NAME = 'back-top';
    var TOGGLE = '[data-toggle="' + NAME + '"]';
    var DATA_KEY = 'fuc.' + NAME;
    var TARGET = 'data-target';
    var VHEIGHT = 'data-visibilityHeight';
    var CALLBACK = 'data-callback';

    var BackTop = function BackTop($ele) {
      var _this = this;

      _classCallCheck$1(this, BackTop);

      this.toggle = function () {
        _this.handleScroll();
      };

      this.show = function () {
        _this.$ele.fadeIn(400);
      };

      this.hide = function () {
        _this.$ele.fadeOut(400);
      };

      this.getCurrentScrollTop = function () {
        if (_this.target === window) {
          return window.pageYOffset || document.body.scrollTop || document.documentElement.scrollTop;
        }
        return _this.target.scrollTop;
      };

      this.scrollToTop = function (e) {
        var scrollTop = _this.getCurrentScrollTop();
        var startTime = Date.now();
        var frameFunc = function frameFunc() {
          var timestamp = Date.now();
          var time = timestamp - startTime;
          _this.setScrollTop(easeInOutCubic(time, scrollTop, 0, 450));
          if (time < 450) {
            reqAnimFrame(frameFunc);
          }
        };
        reqAnimFrame(frameFunc);
        _this.cb(e);
      };

      this.setScrollTop = function (value) {
        if (_this.target === window) {
          document.body.scrollTop = value;
          document.documentElement.scrollTop = value;
        } else {
          _this.target.scrollTop = value;
        }
      };

      this.handleScroll = function () {
        var visibilityHeight = _this.visibilityHeight,
            target = _this.target;

        var scrollTop = getScroll(target, true);
        if (scrollTop > visibilityHeight) {
          _this.show();
        } else {
          _this.hide();
        }
      };

      this.$ele = $ele;
    };

    // BackTop PLUGIN DEFINITION
    // ========================

    BackTop.VERSION = '0.1.0';
    function Plugin(option) {
      return this.each(function () {
        var $this = $$$1(this);
        var data = $this.data(DATA_KEY);
        var target = $this.attr(TARGET) || window;
        target = typeof target === 'string' ? document.querySelector(target) || window : target;

        if (!data) {
          data = new BackTop($this);
          data.target = target;
          data.visibilityHeight = Number($this.attr(VHEIGHT)) || 400;
          data.cb = window[$this.attr(CALLBACK)] || noop;
          $this.data(DATA_KEY, data);
        }

        $$$1(data.target).on('scroll', data.handleScroll);

        if (typeof option === 'string') data[option]();
      });
    }

    var old = $$$1.fn[NAME];

    $$$1.fn[NAME] = Plugin;
    $$$1.fn[NAME].Constructor = BackTop;

    // BackTop NO CONFLICT
    // ==================

    $$$1.fn[NAME].noConflict = function () {
      $$$1.fn[NAME] = old;
      return this;
    };

    // BackTop DATA-API
    // ===============

    $$$1(document).on('click.' + DATA_KEY + '.data-api', TOGGLE, function (e) {
      var $this = $$$1(this);
      var data = $this.data(DATA_KEY);

      if ($this.is('a')) e.preventDefault();
      data.scrollToTop(e);
    });

    $$$1(function () {
      Plugin.call($$$1(TOGGLE), 'toggle');
    });
  }($);

  var loading = function ($$$1) {

    var htmlStr = function htmlStr(loadingText) {
      if (typeof loadingText === 'string') {
        return $$$1('\n        <div class="fuc-loading-mask">\n            <div class="fuc-loading-bg">\n                <div class="fuc-loading-cont">\n                  <span class="fuc-loading-img"></span>\n                  <p>' + loadingText + '</p>\n                </div>\n            </div>\n        </div>\n      ');
      }
      return $$$1('\n      <div class="fuc-loading-mask">\n          <div class="fuc-loading-bg">\n              <div class="fuc-loading-cont">\n                <span class="fuc-loading-img"></span>\n              </div>\n          </div>\n      </div>\n    ');
    };

    var initLoading = function initLoading(me, status) {

      var loadingElement = htmlStr(status);

      // 如果没有传容器默认全局loading
      var ele = me ? me : $$$1('body');

      if (status) {
        ele.append(loadingElement);

        // 如果是局部loading, 用绝对定位, 否则 fixed
        if (me) {
          loadingElement.css('position', 'absolute');
        }
      } else {
        ele.find('.fuc-loading-mask').css('position', 'fixed').remove();
      }
    };

    $$$1.fn.loading = function (status) {
      initLoading(this, status);
      return this;
    };

    $$$1.extend({
      loading: function loading(status) {
        initLoading(undefined, status);
        return this;
      }
    });
  }($);

  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

  var Tooltip = function ($$$1) {
    // TOOLTIP PUBLIC CLASS DEFINITION
    // ===============================

    var Tooltip = function Tooltip(element, options) {
      this.type = null;
      this.options = null;
      this.enabled = null;
      this.timeout = null;
      this.hoverState = null;
      this.$element = null;
      this.inState = null;

      this.init('tooltip', element, options);
    };

    Tooltip.VERSION = '3.3.7';

    Tooltip.TRANSITION_DURATION = 150;

    Tooltip.DEFAULTS = {
      animation: true,
      placement: 'top',
      selector: false,
      template: '<div class="fuc-tooltip" role="tooltip"><div class="fuc-tooltip-arrow"></div><div class="fuc-tooltip-inner"></div></div>',
      trigger: 'hover focus',
      title: '',
      delay: 0,
      html: false,
      container: false,
      viewport: {
        selector: 'body',
        padding: 0
      }
    };

    Tooltip.prototype.init = function (type, element, options) {
      this.enabled = true;
      this.type = type;
      this.$element = $$$1(element);
      this.options = this.getOptions(options);
      this.$viewport = this.options.viewport && $$$1($$$1.isFunction(this.options.viewport) ? this.options.viewport.call(this, this.$element) : this.options.viewport.selector || this.options.viewport);
      this.inState = { click: false, hover: false, focus: false };

      if (this.$element[0] instanceof document.constructor && !this.options.selector) {
        throw new Error('`selector` option must be specified when initializing ' + this.type + ' on the window.document object!');
      }

      var triggers = this.options.trigger.split(' ');

      for (var i = triggers.length; i--;) {
        var trigger = triggers[i];

        if (trigger == 'click') {
          this.$element.on('click.' + this.type, this.options.selector, $$$1.proxy(this.toggle, this));
        } else if (trigger != 'manual') {
          var eventIn = trigger == 'hover' ? 'mouseenter' : 'focusin';
          var eventOut = trigger == 'hover' ? 'mouseleave' : 'focusout';

          this.$element.on(eventIn + '.' + this.type, this.options.selector, $$$1.proxy(this.enter, this));
          this.$element.on(eventOut + '.' + this.type, this.options.selector, $$$1.proxy(this.leave, this));
        }
      }

      this.options.selector ? this._options = $$$1.extend({}, this.options, { trigger: 'manual', selector: '' }) : this.fixTitle();
    };

    Tooltip.prototype.getDefaults = function () {
      return Tooltip.DEFAULTS;
    };

    Tooltip.prototype.getOptions = function (options) {
      options = $$$1.extend({}, this.getDefaults(), this.$element.data(), options);

      if (options.delay && typeof options.delay == 'number') {
        options.delay = {
          show: options.delay,
          hide: options.delay
        };
      }

      return options;
    };

    Tooltip.prototype.getDelegateOptions = function () {
      var options = {};
      var defaults = this.getDefaults();

      this._options && $$$1.each(this._options, function (key, value) {
        if (defaults[key] != value) options[key] = value;
      });

      return options;
    };

    Tooltip.prototype.enter = function (obj) {
      var self = obj instanceof this.constructor ? obj : $$$1(obj.currentTarget).data('bs.' + this.type);

      if (!self) {
        self = new this.constructor(obj.currentTarget, this.getDelegateOptions());
        $$$1(obj.currentTarget).data('bs.' + this.type, self);
      }

      if (obj instanceof $$$1.Event) {
        self.inState[obj.type == 'focusin' ? 'focus' : 'hover'] = true;
      }

      if (self.tip().hasClass('in') || self.hoverState == 'in') {
        self.hoverState = 'in';
        return;
      }

      clearTimeout(self.timeout);

      self.hoverState = 'in';

      if (!self.options.delay || !self.options.delay.show) return self.show();

      self.timeout = setTimeout(function () {
        if (self.hoverState == 'in') self.show();
      }, self.options.delay.show);
    };

    Tooltip.prototype.isInStateTrue = function () {
      for (var key in this.inState) {
        if (this.inState[key]) return true;
      }

      return false;
    };

    Tooltip.prototype.leave = function (obj) {
      var self = obj instanceof this.constructor ? obj : $$$1(obj.currentTarget).data('bs.' + this.type);

      if (!self) {
        self = new this.constructor(obj.currentTarget, this.getDelegateOptions());
        $$$1(obj.currentTarget).data('bs.' + this.type, self);
      }

      if (obj instanceof $$$1.Event) {
        self.inState[obj.type == 'focusout' ? 'focus' : 'hover'] = false;
      }

      if (self.isInStateTrue()) return;

      clearTimeout(self.timeout);

      self.hoverState = 'out';

      if (!self.options.delay || !self.options.delay.hide) return self.hide();

      self.timeout = setTimeout(function () {
        if (self.hoverState == 'out') self.hide();
      }, self.options.delay.hide);
    };

    Tooltip.prototype.show = function () {
      var e = $$$1.Event('show.bs.' + this.type);

      if (this.hasContent() && this.enabled) {
        this.$element.trigger(e);

        var inDom = $$$1.contains(this.$element[0].ownerDocument.documentElement, this.$element[0]);
        if (e.isDefaultPrevented() || !inDom) return;
        var that = this;

        var $tip = this.tip();

        var tipId = this.getUID(this.type);

        this.setContent();
        $tip.attr('id', tipId);
        this.$element.attr('aria-describedby', tipId);

        if (this.options.animation) $tip.addClass('fade');

        var placement = typeof this.options.placement == 'function' ? this.options.placement.call(this, $tip[0], this.$element[0]) : this.options.placement;

        var autoToken = /\s?auto?\s?/i;
        var autoPlace = autoToken.test(placement);
        if (autoPlace) placement = placement.replace(autoToken, '') || 'top';

        $tip.detach().css({ top: 0, left: 0, display: 'block' }).addClass(placement).data('bs.' + this.type, this);

        this.options.container ? $tip.appendTo(this.options.container) : $tip.insertAfter(this.$element);
        this.$element.trigger('inserted.bs.' + this.type);

        var pos = this.getPosition();
        var actualWidth = $tip[0].offsetWidth;
        var actualHeight = $tip[0].offsetHeight;

        if (autoPlace) {
          var orgPlacement = placement;
          var viewportDim = this.getPosition(this.$viewport);

          placement = placement == 'bottom' && pos.bottom + actualHeight > viewportDim.bottom ? 'top' : placement == 'top' && pos.top - actualHeight < viewportDim.top ? 'bottom' : placement == 'right' && pos.right + actualWidth > viewportDim.width ? 'left' : placement == 'left' && pos.left - actualWidth < viewportDim.left ? 'right' : placement;

          $tip.removeClass(orgPlacement).addClass(placement);
        }

        var calculatedOffset = this.getCalculatedOffset(placement, pos, actualWidth, actualHeight);

        this.applyPlacement(calculatedOffset, placement);

        var complete = function complete() {
          var prevHoverState = that.hoverState;
          that.$element.trigger('shown.bs.' + that.type);
          that.hoverState = null;

          if (prevHoverState == 'out') that.leave(that);
        };

        $$$1.support.transition && this.$tip.hasClass('fade') ? $tip.one('bsTransitionEnd', complete).emulateTransitionEnd(Tooltip.TRANSITION_DURATION) : complete();
      }
    };

    Tooltip.prototype.applyPlacement = function (offset, placement) {
      var $tip = this.tip();
      var width = $tip[0].offsetWidth;
      var height = $tip[0].offsetHeight;

      // manually read margins because getBoundingClientRect includes difference
      var marginTop = parseInt($tip.css('margin-top'), 10);
      var marginLeft = parseInt($tip.css('margin-left'), 10);

      // we must check for NaN for ie 8/9
      if (isNaN(marginTop)) marginTop = 0;
      if (isNaN(marginLeft)) marginLeft = 0;

      offset.top += marginTop;
      offset.left += marginLeft;

      // $.fn.offset doesn't round pixel values
      // so we use setOffset directly with our own function B-0
      $$$1.offset.setOffset($tip[0], $$$1.extend({
        using: function using(props) {
          $tip.css({
            top: Math.round(props.top),
            left: Math.round(props.left)
          });
        }
      }, offset), 0);

      $tip.addClass('in');

      // check to see if placing tip in new offset caused the tip to resize itself
      var actualWidth = $tip[0].offsetWidth;
      var actualHeight = $tip[0].offsetHeight;

      if (placement == 'top' && actualHeight != height) {
        offset.top = offset.top + height - actualHeight;
      }

      var delta = this.getViewportAdjustedDelta(placement, offset, actualWidth, actualHeight);

      if (delta.left) offset.left += delta.left;else offset.top += delta.top;

      var isVertical = /top|bottom/.test(placement);
      var arrowDelta = isVertical ? delta.left * 2 - width + actualWidth : delta.top * 2 - height + actualHeight;
      var arrowOffsetPosition = isVertical ? 'offsetWidth' : 'offsetHeight';

      $tip.offset(offset);
      this.replaceArrow(arrowDelta, $tip[0][arrowOffsetPosition], isVertical);
    };

    Tooltip.prototype.replaceArrow = function (delta, dimension, isVertical) {
      this.arrow().css(isVertical ? 'left' : 'top', 50 * (1 - delta / dimension) + '%').css(isVertical ? 'top' : 'left', '');
    };

    Tooltip.prototype.setContent = function () {
      var $tip = this.tip();
      var title = this.getTitle();

      $tip.find('.fuc-tooltip-inner')[this.options.html ? 'html' : 'text'](title);
      $tip.removeClass('fade in top bottom left right');
    };

    Tooltip.prototype.hide = function (callback) {
      var that = this;
      var $tip = $$$1(this.$tip);
      var e = $$$1.Event('hide.bs.' + this.type);

      function complete() {
        if (that.hoverState != 'in') $tip.detach();
        if (that.$element) {
          // TODO: Check whether guarding this code with this `if` is really necessary.
          that.$element.removeAttr('aria-describedby').trigger('hidden.bs.' + that.type);
        }
        callback && callback();
      }

      this.$element.trigger(e);

      if (e.isDefaultPrevented()) return;

      $tip.removeClass('in');

      $$$1.support.transition && $tip.hasClass('fade') ? $tip.one('bsTransitionEnd', complete).emulateTransitionEnd(Tooltip.TRANSITION_DURATION) : complete();

      this.hoverState = null;

      return this;
    };

    Tooltip.prototype.fixTitle = function () {
      var $e = this.$element;
      if ($e.attr('title') || typeof $e.attr('data-original-title') != 'string') {
        $e.attr('data-original-title', $e.attr('title') || '').attr('title', '');
      }
    };

    Tooltip.prototype.hasContent = function () {
      return this.getTitle();
    };

    Tooltip.prototype.getPosition = function ($element) {
      $element = $element || this.$element;

      var el = $element[0];
      var isBody = el.tagName == 'BODY';

      var elRect = el.getBoundingClientRect();
      if (elRect.width == null) {
        // width and height are missing in IE8, so compute them manually; see https://github.com/twbs/bootstrap/issues/14093
        elRect = $$$1.extend({}, elRect, { width: elRect.right - elRect.left, height: elRect.bottom - elRect.top });
      }
      var isSvg = window.SVGElement && el instanceof window.SVGElement;
      // Avoid using $.offset() on SVGs since it gives incorrect results in jQuery 3.
      // See https://github.com/twbs/bootstrap/issues/20280
      var elOffset = isBody ? { top: 0, left: 0 } : isSvg ? null : $element.offset();
      var scroll = { scroll: isBody ? document.documentElement.scrollTop || document.body.scrollTop : $element.scrollTop() };
      var outerDims = isBody ? { width: $$$1(window).width(), height: $$$1(window).height() } : null;

      return $$$1.extend({}, elRect, scroll, outerDims, elOffset);
    };

    Tooltip.prototype.getCalculatedOffset = function (placement, pos, actualWidth, actualHeight) {
      return placement == 'bottom' ? { top: pos.top + pos.height, left: pos.left + pos.width / 2 - actualWidth / 2 } : placement == 'top' ? { top: pos.top - actualHeight, left: pos.left + pos.width / 2 - actualWidth / 2 } : placement == 'left' ? { top: pos.top + pos.height / 2 - actualHeight / 2, left: pos.left - actualWidth } :
      /* placement == 'right' */{ top: pos.top + pos.height / 2 - actualHeight / 2, left: pos.left + pos.width };
    };

    Tooltip.prototype.getViewportAdjustedDelta = function (placement, pos, actualWidth, actualHeight) {
      var delta = { top: 0, left: 0 };
      if (!this.$viewport) return delta;

      var viewportPadding = this.options.viewport && this.options.viewport.padding || 0;
      var viewportDimensions = this.getPosition(this.$viewport);

      if (/right|left/.test(placement)) {
        var topEdgeOffset = pos.top - viewportPadding - viewportDimensions.scroll;
        var bottomEdgeOffset = pos.top + viewportPadding - viewportDimensions.scroll + actualHeight;
        if (topEdgeOffset < viewportDimensions.top) {
          // top overflow
          delta.top = viewportDimensions.top - topEdgeOffset;
        } else if (bottomEdgeOffset > viewportDimensions.top + viewportDimensions.height) {
          // bottom overflow
          delta.top = viewportDimensions.top + viewportDimensions.height - bottomEdgeOffset;
        }
      } else {
        var leftEdgeOffset = pos.left - viewportPadding;
        var rightEdgeOffset = pos.left + viewportPadding + actualWidth;
        if (leftEdgeOffset < viewportDimensions.left) {
          // left overflow
          delta.left = viewportDimensions.left - leftEdgeOffset;
        } else if (rightEdgeOffset > viewportDimensions.right) {
          // right overflow
          delta.left = viewportDimensions.left + viewportDimensions.width - rightEdgeOffset;
        }
      }

      return delta;
    };

    Tooltip.prototype.getTitle = function () {
      var title;
      var $e = this.$element;
      var o = this.options;

      title = $e.attr('data-original-title') || (typeof o.title == 'function' ? o.title.call($e[0]) : o.title);

      return title;
    };

    Tooltip.prototype.getUID = function (prefix) {
      do {
        prefix += ~~(Math.random() * 1000000);
      } while (document.getElementById(prefix));
      return prefix;
    };

    Tooltip.prototype.tip = function () {
      if (!this.$tip) {
        this.$tip = $$$1(this.options.template);
        if (this.$tip.length != 1) {
          throw new Error(this.type + ' `template` option must consist of exactly 1 top-level element!');
        }
      }
      return this.$tip;
    };

    Tooltip.prototype.arrow = function () {
      return this.$arrow = this.$arrow || this.tip().find('.fuc-tooltip-arrow');
    };

    Tooltip.prototype.enable = function () {
      this.enabled = true;
    };

    Tooltip.prototype.disable = function () {
      this.enabled = false;
    };

    Tooltip.prototype.toggleEnabled = function () {
      this.enabled = !this.enabled;
    };

    Tooltip.prototype.toggle = function (e) {
      var self = this;
      if (e) {
        self = $$$1(e.currentTarget).data('bs.' + this.type);
        if (!self) {
          self = new this.constructor(e.currentTarget, this.getDelegateOptions());
          $$$1(e.currentTarget).data('bs.' + this.type, self);
        }
      }

      if (e) {
        self.inState.click = !self.inState.click;
        if (self.isInStateTrue()) self.enter(self);else self.leave(self);
      } else {
        self.tip().hasClass('in') ? self.leave(self) : self.enter(self);
      }
    };

    Tooltip.prototype.destroy = function () {
      var that = this;
      clearTimeout(this.timeout);
      this.hide(function () {
        that.$element.off('.' + that.type).removeData('bs.' + that.type);
        if (that.$tip) {
          that.$tip.detach();
        }
        that.$tip = null;
        that.$arrow = null;
        that.$viewport = null;
        that.$element = null;
      });
    };

    // TOOLTIP PLUGIN DEFINITION
    // =========================

    function Plugin(option) {
      return this.each(function () {
        var $this = $$$1(this);
        var data = $this.data('bs.tooltip');
        var options = (typeof option === 'undefined' ? 'undefined' : _typeof(option)) == 'object' && option;

        if (!data && /destroy|hide/.test(option)) return;
        if (!data) $this.data('bs.tooltip', data = new Tooltip(this, options));
        if (typeof option == 'string') data[option]();
      });
    }
    var old = $$$1.fn.tooltip;

    $$$1.fn.tooltip = Plugin;
    $$$1.fn.tooltip.Constructor = Tooltip;

    // TOOLTIP NO CONFLICT
    // ===================

    $$$1.fn.tooltip.noConflict = function () {
      $$$1.fn.tooltip = old;
      return this;
    };
  }($);

  var _typeof$1 = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

  var Popover = function ($$$1) {

    // POPOVER PUBLIC CLASS DEFINITION
    // ===============================

    var Popover = function Popover(element, options) {
      this.init('popover', element, options);
    };

    if (!$$$1.fn.tooltip) throw new Error('Popover requires tooltip.js');

    Popover.VERSION = '3.3.7';

    Popover.DEFAULTS = $$$1.extend({}, $$$1.fn.tooltip.Constructor.DEFAULTS, {
      placement: 'right',
      trigger: 'click',
      content: '',
      template: '<div class="fuc-popover" role="tooltip"><div class="arrow"></div><h3 class="fuc-popover-title"></h3><div class="fuc-popover-content"></div></div>'
    });

    // NOTE: POPOVER EXTENDS tooltip.js
    // ================================

    Popover.prototype = $$$1.extend({}, $$$1.fn.tooltip.Constructor.prototype);

    Popover.prototype.constructor = Popover;

    Popover.prototype.getDefaults = function () {
      return Popover.DEFAULTS;
    };

    Popover.prototype.setContent = function () {
      var $tip = this.tip();
      var title = this.getTitle();
      var content = this.getContent();

      $tip.find('.fuc-popover-title')[this.options.html ? 'html' : 'text'](title);
      $tip.find('.fuc-popover-content').children().detach().end()[// we use append for html objects to maintain js events
      this.options.html ? typeof content == 'string' ? 'html' : 'append' : 'text'](content);

      $tip.removeClass('fade top bottom left right in');

      // IE8 doesn't accept hiding via the `:empty` pseudo selector, we have to do
      // this manually by checking the contents.
      if (!$tip.find('.fuc-popover-title').html()) $tip.find('.fuc-popover-title').hide();
    };

    Popover.prototype.hasContent = function () {
      return this.getTitle() || this.getContent();
    };

    Popover.prototype.getContent = function () {
      var $e = this.$element;
      var o = this.options;

      return $e.attr('data-content') || (typeof o.content == 'function' ? o.content.call($e[0]) : o.content);
    };

    Popover.prototype.arrow = function () {
      return this.$arrow = this.$arrow || this.tip().find('.arrow');
    };

    // POPOVER PLUGIN DEFINITION
    // =========================

    function Plugin(option) {
      return this.each(function () {
        var $this = $$$1(this);
        var data = $this.data('bs.popover');
        var options = (typeof option === 'undefined' ? 'undefined' : _typeof$1(option)) == 'object' && option;

        if (!data && /destroy|hide/.test(option)) return;
        if (!data) $this.data('bs.popover', data = new Popover(this, options));
        if (typeof option == 'string') data[option]();
      });
    }

    var old = $$$1.fn.popover;

    $$$1.fn.popover = Plugin;
    $$$1.fn.popover.Constructor = Popover;

    // POPOVER NO CONFLICT
    // ===================

    $$$1.fn.popover.noConflict = function () {
      $$$1.fn.popover = old;
      return this;
    };
  }(jQuery);

  /*
   * fuc: message.js v0.1.0
   */

  var prefixCls = 'fuc-message';
  var now = Date.now();
  var seed = 0;
  var defaultDuration = 3;
  var defaultContainer = 'body';
  var defaultTop = void 0;

  function noop$1() {}

  function getUuid() {
    return 'message_' + now + '_' + seed++;
  }

  function notice(content) {
    var duration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultDuration;
    var type = arguments[2];
    var onClose = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : noop$1;

    var $message = $('[data-toggle="message"]');
    var uuid = getUuid();
    var iconType = {
      info: 'info-circle',
      success: 'check-circle',
      error: 'close-circle-o',
      warning: 'exclamation-circle',
      loading: 'loading'
    }[type];
    var style = typeof defaultTop === 'number' ? 'top:' + defaultTop + 'px' : '';

    if (typeof duration === 'function') {
      onClose = duration;
      duration = defaultDuration;
    }

    if ($message.length === 0) {
      $message = $('<div class="' + prefixCls + '" data-toggle="message" style="' + style + '"></div>');
      $(defaultContainer).append($message);
    }

    $message.append('<div class="' + prefixCls + '-notice move-up-enter" id="' + uuid + '">\n          <div class="' + prefixCls + '-notice-content">\n            <div class="' + prefixCls + '-custom-content ' + prefixCls + '-' + type + '">\n              <i class="iconfont icon-' + iconType + '"></i>\n              <span>' + content + '</span>\n            </div>\n          </div>\n        </div>');

    function destory() {
      var $item = $('#' + uuid);
      $item.addClass('move-up-leave');
      setTimeout(function () {
        $item.remove();
        onClose();
      }, 300);
    }

    if (duration === 0) {
      return function () {
        destory();
      };
    }

    setTimeout(function () {
      destory();
    }, duration * 1000);
  }

  var Message = $.Message = {
    info: function info(content, duration, onClose) {
      return notice(content, duration, 'info', onClose);
    },
    success: function success(content, duration, onClose) {
      return notice(content, duration, 'success', onClose);
    },
    error: function error(content, duration, onClose) {
      return notice(content, duration, 'error', onClose);
    },
    warning: function warning(content, duration, onClose) {
      return notice(content, duration, 'warning', onClose);
    },
    loading: function loading(content, duration, onClose) {
      return notice(content, duration, 'loading', onClose);
    },
    config: function config(options) {
      if (options.top !== undefined) {
        defaultTop = options.top;
      }
      if (options.duration !== undefined) {
        defaultDuration = options.duration;
      }
      if (options.getContainer !== undefined) {
        defaultContainer = options.getContainer;
      }
    }
  };

  var _typeof$2 = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

  var Modal = function ($$$1) {

    var Modal = function Modal(element, options) {
      this.options = options;
      this.$body = $$$1(document.body);
      this.$element = $$$1(element);
      this.$dialog = this.$element.find('.fuc-modal-dialog');
      this.$backdrop = null;
      this.isShown = null;
      this.originalBodyPad = null;
      this.scrollbarWidth = 0;
      this.ignoreBackdropClick = false;

      if (this.options.remote) {
        this.$element.find('.fuc-modal-content').load(this.options.remote, $$$1.proxy(function () {
          this.$element.trigger('loaded.fuc.modal');
        }, this));
      }
    };

    Modal.VERSION = '3.3.7';

    Modal.TRANSITION_DURATION = 300;
    Modal.BACKDROP_TRANSITION_DURATION = 150;

    Modal.DEFAULTS = {
      backdrop: true,
      keyboard: true,
      show: true
    };

    Modal.prototype.toggle = function (_relatedTarget) {
      return this.isShown ? this.hide() : this.show(_relatedTarget);
    };

    Modal.prototype.show = function (_relatedTarget) {
      var that = this;
      var e = $$$1.Event('show.fuc.modal', { relatedTarget: _relatedTarget });

      this.$dialog.addClass('fuc-modal-animating');

      this.$element.trigger(e);

      if (this.isShown || e.isDefaultPrevented()) return;

      this.isShown = true;

      this.checkScrollbar();
      this.setScrollbar();
      this.$body.addClass('fuc-modal-open');

      this.escape();
      this.resize();

      this.$element.on('click.dismiss.fuc.modal', '[data-dismiss="modal"]', $$$1.proxy(this.hide, this));

      this.$dialog.on('mousedown.dismiss.fuc.modal', function () {
        that.$element.one('mouseup.dismiss.fuc.modal', function (e) {
          if ($$$1(e.target).is(that.$element)) that.ignoreBackdropClick = true;
        });
      });

      this.backdrop(function () {
        var transition = $$$1.support.transition && that.$element.hasClass('fade');

        if (!that.$element.parent().length) {
          that.$element.appendTo(that.$body); // don't move modals dom position
        }

        that.$element.show().scrollTop(0);

        that.adjustDialog();

        if (transition) {
          that.$element[0].offsetWidth; // force reflow
        }

        that.$element.addClass('in');

        that.enforceFocus();

        var e = $$$1.Event('shown.fuc.modal', { relatedTarget: _relatedTarget });

        transition ? that.$dialog // wait for modal to slide in
        .one('bsTransitionEnd', function () {
          that.$element.trigger('focus').trigger(e);
          that.$dialog.removeClass('fuc-modal-animating');
        }).emulateTransitionEnd(Modal.TRANSITION_DURATION) : that.$element.trigger('focus').trigger(e);
      });
    };

    Modal.prototype.hide = function (e) {
      if (e) e.preventDefault();

      e = $$$1.Event('hide.fuc.modal');
      this.$dialog.addClass('fuc-modal-animating');

      this.$element.trigger(e);

      if (!this.isShown || e.isDefaultPrevented()) return;

      this.isShown = false;

      this.escape();
      this.resize();

      $$$1(document).off('focusin.fuc.modal');

      this.$element.removeClass('in').off('click.dismiss.fuc.modal').off('mouseup.dismiss.fuc.modal');

      this.$dialog.off('mousedown.dismiss.fuc.modal');

      $$$1.support.transition && this.$element.hasClass('fade') ? this.$element.one('bsTransitionEnd', $$$1.proxy(this.hideModal, this)).emulateTransitionEnd(Modal.TRANSITION_DURATION) : this.hideModal();
    };

    Modal.prototype.enforceFocus = function () {
      $$$1(document).off('focusin.fuc.modal') // guard against infinite focus loop
      .on('focusin.fuc.modal', $$$1.proxy(function (e) {
        if (document !== e.target && this.$element[0] !== e.target && !this.$element.has(e.target).length) {
          this.$element.trigger('focus');
        }
      }, this));
    };

    Modal.prototype.escape = function () {
      if (this.isShown && this.options.keyboard) {
        this.$element.on('keydown.dismiss.fuc.modal', $$$1.proxy(function (e) {
          e.which == 27 && this.hide();
        }, this));
      } else if (!this.isShown) {
        this.$element.off('keydown.dismiss.fuc.modal');
      }
    };

    Modal.prototype.resize = function () {
      if (this.isShown) {
        $$$1(window).on('resize.fuc.modal', $$$1.proxy(this.handleUpdate, this));
      } else {
        $$$1(window).off('resize.fuc.modal');
      }
    };

    Modal.prototype.hideModal = function () {
      var that = this;
      this.$element.hide();
      this.backdrop(function () {
        that.$body.removeClass('fuc-modal-open');
        that.resetAdjustments();
        that.resetScrollbar();
        that.$element.trigger('hidden.fuc.modal');
        that.$dialog.removeClass('fuc-modal-animating');
      });
    };

    Modal.prototype.removeBackdrop = function () {
      this.$backdrop && this.$backdrop.remove();
      this.$backdrop = null;
    };

    Modal.prototype.backdrop = function (callback) {
      var that = this;
      var animate = this.$element.hasClass('fade') ? 'fade' : '';

      if (this.isShown && this.options.backdrop) {
        var doAnimate = $$$1.support.transition && animate;

        this.$backdrop = $$$1(document.createElement('div')).addClass('fuc-modal-backdrop ' + animate).appendTo(this.$body);

        this.$element.on('click.dismiss.fuc.modal', $$$1.proxy(function (e) {
          if (this.ignoreBackdropClick) {
            this.ignoreBackdropClick = false;
            return;
          }
          if (e.target !== e.currentTarget) return;
          this.options.backdrop == 'static' ? this.$element[0].focus() : this.hide();
        }, this));

        if (doAnimate) this.$backdrop[0].offsetWidth; // force reflow

        this.$backdrop.addClass('in');

        if (!callback) return;

        doAnimate ? this.$backdrop.one('bsTransitionEnd', callback).emulateTransitionEnd(Modal.BACKDROP_TRANSITION_DURATION) : callback();
      } else if (!this.isShown && this.$backdrop) {
        this.$backdrop.removeClass('in');

        var callbackRemove = function callbackRemove() {
          that.removeBackdrop();
          callback && callback();
        };
        $$$1.support.transition && this.$element.hasClass('fade') ? this.$backdrop.one('bsTransitionEnd', callbackRemove).emulateTransitionEnd(Modal.BACKDROP_TRANSITION_DURATION) : callbackRemove();
      } else if (callback) {
        callback();
      }
    };

    // these following methods are used to handle overflowing modals

    Modal.prototype.handleUpdate = function () {
      this.adjustDialog();
    };

    Modal.prototype.adjustDialog = function () {
      var modalIsOverflowing = this.$element[0].scrollHeight > document.documentElement.clientHeight;

      this.$element.css({
        paddingLeft: !this.bodyIsOverflowing && modalIsOverflowing ? this.scrollbarWidth : '',
        paddingRight: this.bodyIsOverflowing && !modalIsOverflowing ? this.scrollbarWidth : ''
      });
    };

    Modal.prototype.resetAdjustments = function () {
      this.$element.css({
        paddingLeft: '',
        paddingRight: ''
      });
    };

    Modal.prototype.checkScrollbar = function () {
      var fullWindowWidth = window.innerWidth;
      if (!fullWindowWidth) {
        // workaround for missing window.innerWidth in IE8
        var documentElementRect = document.documentElement.getBoundingClientRect();
        fullWindowWidth = documentElementRect.right - Math.abs(documentElementRect.left);
      }
      this.bodyIsOverflowing = document.body.clientWidth < fullWindowWidth;
      this.scrollbarWidth = this.measureScrollbar();
    };

    Modal.prototype.setScrollbar = function () {
      var bodyPad = parseInt(this.$body.css('padding-right') || 0, 10);
      this.originalBodyPad = document.body.style.paddingRight || '';
      if (this.bodyIsOverflowing) this.$body.css('padding-right', bodyPad + this.scrollbarWidth);
    };

    Modal.prototype.resetScrollbar = function () {
      this.$body.css('padding-right', this.originalBodyPad);
    };

    Modal.prototype.measureScrollbar = function () {
      // thx walsh
      var scrollDiv = document.createElement('div');
      scrollDiv.className = 'fuc-modal-scrollbar-measure';
      this.$body.append(scrollDiv);
      var scrollbarWidth = scrollDiv.offsetWidth - scrollDiv.clientWidth;
      this.$body[0].removeChild(scrollDiv);
      return scrollbarWidth;
    };

    // MODAL PLUGIN DEFINITION
    // =======================

    function Plugin(option, _relatedTarget) {
      return this.each(function () {
        var $this = $$$1(this);
        var data = $this.data('fuc.modal');
        var options = $$$1.extend({}, Modal.DEFAULTS, $this.data(), (typeof option === 'undefined' ? 'undefined' : _typeof$2(option)) == 'object' && option);

        if (!data) $this.data('fuc.modal', data = new Modal(this, options));
        if (typeof option == 'string') data[option](_relatedTarget);else if (options.show) data.show(_relatedTarget);
      });
    }

    function baseConf(config) {
      // 做唯一性检测
      if ($$$1('#fucBaseModal').length !== 0) {
        $$$1('#fucBaseModal').remove();
      }

      // 根据conf构建DOM结构
      var $close = config.closable ? $$$1('<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span class="icon icon-close" aria-hidden="true"></span></button>') : '';
      var $title = config.title ? $$$1('<h4 class="fuc-modal-title">' + config.title + '</h4>') : '';
      var $header = $close || $title ? $$$1('<div class="fuc-modal-header"></div>').append($close).append($title) : '';
      var $body = config.body ? $$$1('<div class="fuc-modal-body">' + config.body + '</div>') : '';
      var $cancelBtn = config.cancelBtn ? $$$1('<button type="button" class="fuc-btn fuc-btn-default">' + config.cancelBtn.text + '</button>') : '';

      if ($cancelBtn && config.cancelBtn.callBack) {
        $cancelBtn.on('click', function () {
          config.cancelBtn.callBack();
          $$$1('#fucBaseModal').modal('hide'); // 隐藏模态框
        });
      }

      var $sureBtn = config.sureBtn ? $$$1('<button type="button" class="fuc-btn fuc-btn-primary">' + config.sureBtn.text + '</button>') : '';

      if ($sureBtn && config.sureBtn.callBack) {
        $sureBtn.on('click', function () {
          config.sureBtn.callBack();
          $$$1('#fucBaseModal').modal('hide'); // 隐藏模态框
        });
      }

      var $footer = $cancelBtn || $sureBtn ? $$$1('<div class="fuc-modal-footer"></div>').append($cancelBtn).append($sureBtn) : '';
      var $content = $$$1('<div class="fuc-modal-content"></div>').append($header).append($body).append($footer);
      var $dialog = $$$1('<div class="fuc-modal-dialog" role="document"></div>').append($content);
      var $modal = $$$1('<div class="fuc-modal fade" id="fucBaseModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel"></div>').append($dialog);
      if (config.className && typeof config.className === 'string') {
        $modal.addClass(config.className);
      }

      // 添加事件
      $$$1('body').append($modal);
      // 唤起modal
      $$$1('#fucBaseModal').modal();
    }

    var old = $$$1.fn.modal;

    $$$1.fn.modal = Plugin;
    $$$1.fn.modal.Constructor = Modal;
    $$$1.Modal = {
      conf: function conf(_conf) {
        return baseConf(_conf);
      }
    };

    // MODAL NO CONFLICT
    // =================

    $$$1.fn.modal.noConflict = function () {
      $$$1.fn.modal = old;
      return this;
    };

    // MODAL DATA-API
    // ==============

    $$$1(document).on('click.fuc.modal.data-api', '[data-toggle="modal"]', function (e) {
      var $this = $$$1(this);
      var href = $this.attr('href');
      var $target = $$$1($this.attr('data-target') || href && href.replace(/.*(?=#[^\s]+$)/, '')); // strip for ie7
      var option = $target.data('fuc.modal') ? 'toggle' : $$$1.extend({ remote: !/#/.test(href) && href }, $target.data(), $this.data());

      if ($this.is('a')) e.preventDefault();

      $target.one('show.fuc.modal', function (showEvent) {
        if (showEvent.isDefaultPrevented()) return; // only register focus restorer if modal will actually get shown
        $target.one('hidden.fuc.modal', function () {
          $this.is(':visible') && $this.trigger('focus');
        });
      });
      Plugin.call($target, option, this);
    });
  }($);

  function _classCallCheck$2(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  var Input = function ($$$1) {
    /**
     * ------------------------------------------------------------------------
     * 配置信息
     * ------------------------------------------------------------------------
     */
    var NAME = 'input';
    var DATA_KEY = 'fuc.input';
    var EVENT_KEY = '.' + DATA_KEY;
    var DATA_API_KEY = '.data-api';
    var JQUERY_NO_CONFLICT = $$$1.fn[NAME];
    var NumberAdjust = 10000000000000000;
    var ClassName = {
      InputGroup: 'fuc-input-group',
      Input: 'fuc-input-control',
      InputErr: 'fuc-input-err',
      InputErrMsg: 'fuc-input-msg-err',
      step: {
        STEP_BTN_BOX: 'fuc-input-group-stepbox',
        STEP_BTN_UP: 'fuc-input-up',
        STEP_BTN_DN: 'fuc-input-dn'
      }
    };
    var Selector = {
      publicAttr: {
        Group: 'fuc-inputgroup-type',
        Input: 'fuc-input-type'
      },
      step: {
        STEP_GROUP_TYPE: '[fuc-inputgroup-type="step"]',
        STEP_TYPE: '[fuc-input-type="step"]',
        attr: {
          STEP: 'data-step',
          MIN: 'data-min',
          MAX: 'data-max'
        }
      },
      number: {
        NUMBER_GROUP_TYPE: '[fuc-inputgroup-type="number"]',
        NUMBER_TYPE: '[fuc-input-type="number"]'
      }
    };
    var Event = {
      KEYDOWN: 'keydown' + EVENT_KEY + DATA_API_KEY,
      KEYUP: 'keyup' + EVENT_KEY + DATA_API_KEY,
      CLICK: 'click' + EVENT_KEY + DATA_API_KEY,
      BLUR: 'blur' + EVENT_KEY + DATA_API_KEY
    };
    var StepData = {
      name: 'step',
      selector: Selector.step,
      className: ClassName.step,
      defaultAttr: {
        step: 1,
        min: 0,
        max: 100
      }
    };
    // 数字[48~57],小键盘数字[96~105],方向键[37~40],other[delate-8/46、tab-9、enter-13/108、dot-190/110]
    var isNumberKeyCode = function isNumberKeyCode(key) {
      return key >= 48 && key <= 57 || key >= 96 && key <= 105;
    };
    var isDotKeyCode = function isDotKeyCode(key) {
      return key === 190 || key === 110;
    };
    var isDireKeyCode = function isDireKeyCode(key) {
      return key >= 37 && key <= 40;
    };
    var isDelKeyCode = function isDelKeyCode(key) {
      return key === 8 || key === 46;
    };
    var isTabKeyCode = function isTabKeyCode(key) {
      return key === 9;
    };
    var isEnterKeyCode = function isEnterKeyCode(key) {
      return key === 13 || key === 108;
    };

    /**
     * ------------------------------------------------------------------------
     * class Input
     * ------------------------------------------------------------------------
     */

    var Input = function () {
      function Input(element) {
        _classCallCheck$2(this, Input);

        this.els = element;
        if (element.hasClass(ClassName.InputGroup)) {
          this.type = 'groupType';
          this.groupType = element.attr(Selector.publicAttr.Group) || '';
        } else if (element.hasClass(ClassName.Input)) {
          this.type = 'inputType';
          this.inputType = element.attr(Selector.publicAttr.Input) || '';
        }
        // console.log('constructor Input ', this);
      }

      // 初始化Number类型


      Input.prototype.initNumber = function initNumber() {
        var $els = $$$1(this);
        $els.on(Event.KEYDOWN, function (event) {
          return isNumberKeyCode(event.keyCode) || isDireKeyCode(event.keyCode) || isDelKeyCode(event.keyCode) || isTabKeyCode(event.keyCode) || isEnterKeyCode(event.keyCode);
        });

        $els.on(Event.KEYUP, function () {
          // 纠正中文
          $$$1(this).val($$$1(this).val().replace(/[^\d]/g, ''));
        });
      };

      // 设置微调输入框


      Input.prototype.initStep = function initStep() {
        var name = StepData.name,
            selector = StepData.selector,
            className = StepData.className,
            defaultAttr = StepData.defaultAttr;

        if ($$$1(this).attr(Selector.publicAttr.Group) !== name) return false;
        var $els = $$$1(this).html('');
        var step = Number($els.attr(selector.attr.STEP)) || defaultAttr.step;
        var min = Number($els.attr(selector.attr.MIN)) || defaultAttr.min;
        var max = Number($els.attr(selector.attr.MAX)) || defaultAttr.max;
        var $ipt = $$$1('<input type="text" ' + Selector.publicAttr.Input + '="' + name + '" class="' + ClassName.Input + '">');
        var $btnBox = $$$1('<span class="' + className.STEP_BTN_BOX + '"><i class="' + className.STEP_BTN_UP + '">+</i><i class="' + className.STEP_BTN_DN + '">-</i></span>');
        $els.append($ipt).append($btnBox);

        var addStep = function addStep() {
          var val = Number($ipt.val().replace(/[^\d|.\-+]/g, ''));
          val = (val * NumberAdjust + step * NumberAdjust) / NumberAdjust;
          if (val > max) val = max;
          return val;
        };
        var subStep = function subStep() {
          var val = Number($ipt.val().replace(/[^\d|.\-+]/g, ''));
          val = (val * NumberAdjust - step * NumberAdjust) / NumberAdjust;
          if (val < min) val = min;
          return val;
        };

        $btnBox.find('.' + className.STEP_BTN_UP).on(Event.CLICK, function () {
          $ipt.val(addStep());
        });
        $btnBox.find('.' + className.STEP_BTN_DN).on(Event.CLICK, function () {
          $ipt.val(subStep());
        });

        $ipt.on(Event.KEYDOWN, function (event) {
          console.log(this.value);
          var val = this.value.split('');
          val.splice(this.selectionStart, 0, event.key);
          // const res = Number(val.join('')); // 获取输入之后的数字，如果超出设置的max/min则返回false

          if (isDotKeyCode(event.keyCode)) {
            return this.value.indexOf('.') === -1;
          }

          return isNumberKeyCode(event.keyCode)
          // (isNumberKeyCode(event.keyCode) && res < max && res > min)
          || isDelKeyCode(event.keyCode) || isTabKeyCode(event.keyCode) || isEnterKeyCode(event.keyCode) || isDireKeyCode(event.keyCode) && event.keyCode !== 38; // [上]时返回false，纠正光标位置
        }).on(Event.KEYUP, function (event) {
          var val = Number($ipt.val().replace(/[^\d|.\-+]/g, '')); // 纠正中文
          if (isNaN(val)) val = 0;
          if (isDotKeyCode(event.keyCode)) {
            var p = this.value.indexOf('.');
            console.log(p, this.value.length, val);
            if (p === this.value.length - 1) {
              // 如果是最后一位输入【.】直接return，不要Number
              val = $ipt.val();
            }
            if (val > max) val = max;else if (val < min) val = min;
            $$$1(this).val(val);
            return true;
          }
          if (isNumberKeyCode(event.keyCode) || isDelKeyCode(event.keyCode)) {
            if (val > max) val = max;else if (val < min) val = min;
          } else if (isDireKeyCode(event.keyCode) && event.keyCode === 38) {
            // 上
            val = addStep();
          } else if (isDireKeyCode(event.keyCode) && event.keyCode === 40) {
            // 下
            val = subStep();
          }
          $$$1(this).val(val);
        }).on(Event.BLUR, function (event) {
          console.log(this.value);
          var val = Number($ipt.val().replace(/[^\d|.\-+]/g, '')); // 纠正中文
          if (isNaN(val)) val = 0;
          if (isNumberKeyCode(event.keyCode) || isDelKeyCode(event.keyCode) || isDotKeyCode(event.keyCode)) {
            if (val > max) val = max;else if (val < min) val = min;
          } else if (isDireKeyCode(event.keyCode) && event.keyCode === 38) {
            // 上
            val = addStep();
          } else if (isDireKeyCode(event.keyCode) && event.keyCode === 40) {
            // 下
            val = subStep();
          }
          $$$1(this).val(val);
        });
      };

      // get value


      Input.prototype.getValue = function getValue() {
        var $els = $$$1(this);
        switch ($els.attr(Selector.publicAttr.Group)) {
          case 'step':
            return $els.find('.' + ClassName.Input + StepData.selector.STEP_TYPE).val();
          case 'number':
          case 'phone':
            {
              var $ipts = [];
              $els.find('.' + ClassName.Input + '[' + Selector.publicAttr.Input + '="number"]').each(function () {
                $ipts.push($$$1(this).val());
              });
              return $ipts;
            }
          default:
            return $els.find('.' + ClassName.Input).val();
        }
      };

      // 设置异常状态


      Input.prototype.setErrorStatus = function setErrorStatus(msg) {
        var $els = $$$1(this);
        if (!$els.hasClass(ClassName.InputErr)) $els.addClass(ClassName.InputErr);
        if (msg) {
          if ($els.find('.' + ClassName.InputErrMsg).length < 1) $els.append('<div class="' + ClassName.InputErrMsg + '"></div>');
          $els.find('.' + ClassName.InputErrMsg).text(msg);
        }
      };
      // 清除异常状态


      Input.prototype.clearErrorStatus = function clearErrorStatus() {
        var $els = $$$1(this);
        $els.removeClass(ClassName.InputErr);
        $els.find('.' + ClassName.InputErrMsg).remove();
      };

      // $.fn


      Input._jQueryInterface = function _jQueryInterface(config, value) {
        var ipt = $$$1(this).data(DATA_KEY);
        if (!ipt) {
          ipt = new Input(this);
          $$$1(this).data(DATA_KEY, ipt);
        }

        if (config === 'getValue') {
          var values = {};
          this.each(function () {
            var name = $$$1(this).attr('data-name');
            var value = ipt[config].bind(this)();

            if (name) {
              var _Object$assign;

              Object.assign(values, (_Object$assign = {}, _Object$assign[name] = value, _Object$assign));
            }
          });
          return values;
        }

        return this.each(function (index, el) {
          switch (config) {
            case 'initNumber':
            case 'initStep':
            case 'clearErrorStatus':
              ipt[config].bind(el)();
              break;
            case 'setErrorStatus':
              ipt[config].bind(el)(value);
              break;
            default:
              break;
          }
        });
      };

      return Input;
    }();

    /**
     * ------------------------------------------------------------------------
     * jQuery
     * ------------------------------------------------------------------------
     */


    $$$1.fn[NAME] = Input._jQueryInterface;
    $$$1.fn[NAME].Constructor = Input;
    $$$1.fn[NAME].noConflict = function () {
      $$$1.fn[NAME] = JQUERY_NO_CONFLICT;
      return Input._jQueryInterface;
    };

    /**
     * ------------------------------------------------------------------------
     * init
     * ------------------------------------------------------------------------
     */
    $$$1(function () {
      $$$1('.' + ClassName.Input + Selector.number.NUMBER_TYPE).input('initNumber');
      $$$1('.' + ClassName.InputGroup + Selector.step.STEP_GROUP_TYPE).input('initStep');
    });

    return Input;
  }($);

  function _classCallCheck$3(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  // 获取文件类型
  var getFileType = function getFileType(name) {
    var startIndex = name.lastIndexOf('.');
    if (startIndex !== -1) {
      return name.substring(startIndex + 1, name.length).toLowerCase();
    }
    return '';
  };

  var Upload = function ($$$1) {

    var NAME = 'upload';
    var DATA_KEY = 'fuc.upload';
    var JQUERY_NO_CONFLICT = $$$1.fn[NAME];

    var Upload = function () {
      function Upload(element, options) {
        var _this = this;

        _classCallCheck$3(this, Upload);

        this.init = function (file, target) {
          // 判断是否支持FormData, 根据支持情况走不同方法
          if (file) {
            var name = file.name,
                size = file.size;
            var _options = _this.options,
                limitSize = _options.limitSize,
                thumbnail = _options.thumbnail,
                allowType = _options.allowType,
                onStart = _options.onStart;
            // 校验大小

            if (Math.ceil(size / 1024) > limitSize) {
              return _this.handleUpload('\u6587\u4EF6\u5927\u5C0F\u8D85\u9650\uFF0C\u8BF7\u538B\u7F29\u81F3' + limitSize / 1024 + 'M\u4EE5\u5185', null);
            }
            // 校验格式
            var type = getFileType(name);
            if (thumbnail && !/^(jpeg|jpg|png)$/i.test(type) || allowType.indexOf(type) === -1) {
              return _this.handleUpload('\u6587\u4EF6\u683C\u5F0F\u4E0D\u6B63\u786E\uFF0C\u8BF7\u4E0A\u4F20' + (thumbnail ? '图片' : allowType.join(',')) + '\u683C\u5F0F\u7684\u6587\u4EF6', null);
            }
            onStart && onStart();

            _this.ajaxSubmit(file, _this.handleUpload);
          } else {
            _this.formSubmit(target, _this.handleUpload);
          }
        };

        this.handleUpload = function (err, res, file) {
          var _options2 = _this.options,
              thumbnail = _options2.thumbnail,
              limitNum = _options2.limitNum,
              onChange = _options2.onChange,
              onEnd = _options2.onEnd,
              handleUpload = _options2.handleUpload;

          try {
            res = JSON.parse(res);
          } catch (e) {
            err = '接口返回内容解析错误';
            res = null;
          }
          //记录文件数量
          if (!err) {
            _this.fileList.push(res.data);

            if (!handleUpload) {
              if (_this.fileList.length >= limitNum) {
                _this.disabled();
              }
              //插入dom
              var item = thumbnail ? '<div class="item"><img src="' + res.data + '"/><span class="delete" data-id="' + res.data + '"></span></div>' : '<div class="item">' + (file ? file.name || '文件' : '文件') + '<span class="delete" data-id="' + res.data + '">\u5220\u9664</span></div>';
              _this.$element.find('.file-list').append(item);
            }

            //如果handleUpload是个方法就执行
            if (handleUpload && $$$1.isFunction(handleUpload)) {
              handleUpload();
            }
          }
          onEnd && onEnd();
          onChange && onChange(err, res, _this.fileList);
        };

        this.disabled = function () {
          var disabled = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

          if (disabled) {
            _this.$input.attr('disabled', 'disabled');
            _this.$element.addClass('disabled');
          } else {
            _this.$input.removeAttr('disabled');
            _this.$element.removeClass('disabled');
          }
        };

        this.formSubmit = function (target, cb) {
          var _options3 = _this.options,
              url = _options3.url,
              method = _options3.method;

          var count = _this.fileList.length;
          var iframeName = 'upload_iframe_' + (count + 1);
          var iframe = $$$1('<iframe id="test" name="' + iframeName + '" style="display: none"></iframe>');
          var formName = 'form_' + iframeName;
          var form = $$$1('<form name="' + formName + '" method="' + method + '" target="' + iframeName + '" action="' + url + '" style="display:none" enctype="multipart/form-data"/>');
          var colfile = $$$1(target).clone(true);
          $$$1(target).replaceWith(colfile);

          form.append($$$1(target));
          $$$1(document.body).append(iframe).append(form);
          //提交
          form.submit();
          $$$1(target).val('');
          iframe.on('load', function () {
            var contents = $$$1(this).contents().get(0);
            var res = $$$1(contents).find('body').text();
            cb(null, res);
            iframe.remove();
            form.remove();
          });
        };

        this.ajaxSubmit = function (file, cb) {
          var _options4 = _this.options,
              url = _options4.url,
              method = _options4.method;

          var name = _this.$input.attr('name');
          var data = new FormData();
          data.append(name, file);
          $$$1.ajax({
            url: url,
            data: data,
            type: method,
            processData: false,
            mimeType: 'multipart/form-data',
            contentType: false, //multipart/form-data;
            success: function success(res) {
              cb(null, res, file);
            },
            error: function error(err) {
              cb(err, null, file);
            }
          });
        };

        this.defaults = {
          url: '',
          method: 'post',
          drag: false, //是否允许拖动上传，默认不允许
          thumbnail: false, //是否展示缩略图，默认false
          limitSize: 10240, //文件大小限制，默认10M
          limitNum: 1, //允许上传的文件数量，超出后不再显示增加按钮
          allowType: ['jpg', 'png'],
          onChange: null, //组件变化的回调，包括上传成功或删除上传的图片
          onStart: null, //开始上传的回调
          onEnd: null, //上传结束的回调

          handleUpload: null //加这个以后，自己处理后续的业务逻辑了
        };
        this.options = $$$1.extend({}, this.defaults, options);
        this.$element = $$$1(element);
        this.$input = $$$1(element).find('input[type="file"]');
        this.fileList = []; //上传成功的文件url列表
        this.attachEvent();
      }

      //绑定事件


      Upload.prototype.attachEvent = function attachEvent() {
        var _this2 = this;

        var _options5 = this.options,
            drag = _options5.drag,
            limitNum = _options5.limitNum,
            onChange = _options5.onChange;

        //透明的input标签

        this.$element.on('change', 'input[type="file"]', function (e) {

          if (!$$$1(e.target).val() || $$$1(e.target).val() === '') {
            return;
          }

          // 判断是否支持FormData, 根据支持情况走不同方法
          if (window.FormData) {
            var file = _this2.$input[0].files[0];
            _this2.$input.val('');
            _this2.init(file);
          } else {
            _this2.init(null, e.target);
          }
        });

        //拖拽事件
        if (drag && window.FormData) {
          $$$1(document.body).on({
            drop: function drop(e) {
              //拖后放
              e.preventDefault();
            },
            dragenter: function dragenter(e) {
              //拖进
              e.preventDefault();
            },
            dragover: function dragover(e) {
              //拖来拖去
              e.preventDefault();
            }
          });
          $$$1(document.body).on('drop', 'label', function (e) {
            e.preventDefault();
            var file = e.originalEvent.dataTransfer.files[0];
            _this2.init(file);
          });
        }

        //删除按钮
        this.$element.on('click', '.delete', function (e) {
          var target = $$$1(e.target);
          var item = target.parent('.item');
          var id = target.attr('data-id');
          _this2.fileList.splice(item.index(), 1);
          if (_this2.fileList.length < limitNum) {
            _this2.disabled(false);
          }
          target.parent('.item').remove();
          // onChange回调
          onChange && onChange(null, null, _this2.fileList);
        });
      };

      //文件校验


      //上传完成后的回调函数


      //禁用


      // 构建隐藏的iframe，通过form提交，适用于低版本浏览器，暂不支持跨域


      // HTML5 formData 上传


      // Static
      Upload._jQueryInterface = function _jQueryInterface(config) {
        return this.each(function () {
          var data = $$$1(this).data(DATA_KEY);

          if (!data) {
            data = new Upload(this, config);
            $$$1(this).data(DATA_KEY, data);
          }

          if (config === 'active') {
            data[config]();
          }
        });
      };

      return Upload;
    }();

    /**
     * ------------------------------------------------------------------------
     * jQuery
     * ------------------------------------------------------------------------
     */

    $$$1.fn[NAME] = Upload._jQueryInterface;
    $$$1.fn[NAME].Constructor = Upload;
    $$$1.fn[NAME].noConflict = function () {
      $$$1.fn[NAME] = JQUERY_NO_CONFLICT;
      return Upload._jQueryInterface;
    };

    return Upload;
  }($);

  var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

  /**
   * --------------------------------------------------------------------------
   * Bootstrap (v4.0.0): util.js
   * Licensed under MIT (https://github.com/twbs/bootstrap/blob/master/LICENSE)
   * --------------------------------------------------------------------------
   */

  var Util = function ($$$1) {
    /**
     * ------------------------------------------------------------------------
     * Private TransitionEnd Helpers
     * ------------------------------------------------------------------------
     */

    var transition = false;

    var MAX_UID = 1000000;

    // 处理模板正则表达式
    var tmplRe = /\{\{:([\w-]+)\}\}/g;

    // Shoutout AngusCroll (https://goo.gl/pxwQGp)
    function toType(obj) {
      return {}.toString.call(obj).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
    }

    function getSpecialTransitionEndEvent() {
      return {
        bindType: transition.end,
        delegateType: transition.end,
        handle: function handle(event) {
          if ($$$1(event.target).is(this)) {
            return event.handleObj.handler.apply(this, arguments); // eslint-disable-line prefer-rest-params
          }
          return undefined; // eslint-disable-line no-undefined
        }
      };
    }

    function transitionEndTest() {
      if (typeof window !== 'undefined' && window.QUnit) {
        return false;
      }

      return {
        end: 'transitionend'
      };
    }

    function transitionEndEmulator(duration) {
      var _this = this;

      var called = false;

      $$$1(this).one(Util.TRANSITION_END, function () {
        called = true;
      });

      setTimeout(function () {
        if (!called) {
          Util.triggerTransitionEnd(_this);
        }
      }, duration);

      return this;
    }

    function setTransitionEndSupport() {
      transition = transitionEndTest();

      $$$1.fn.emulateTransitionEnd = transitionEndEmulator;

      if (Util.supportsTransitionEnd()) {
        $$$1.event.special[Util.TRANSITION_END] = getSpecialTransitionEndEvent();
      }
    }

    function escapeId(selector) {
      // We escape IDs in case of special selectors (selector = '#myId:something')
      // $.escapeSelector does not exist in jQuery < 3
      selector = typeof $$$1.escapeSelector === 'function' ? $$$1.escapeSelector(selector).substr(1) : selector.replace(/(:|\.|\[|\]|,|=|@)/g, '\\$1');

      return selector;
    }

    /**
     * --------------------------------------------------------------------------
     * Public Util Api
     * --------------------------------------------------------------------------
     */

    var Util = {

      TRANSITION_END: 'bsTransitionEnd',

      getUID: function getUID(prefix) {
        do {
          // eslint-disable-next-line no-bitwise
          prefix += ~~(Math.random() * MAX_UID); // "~~" acts like a faster Math.floor() here
        } while (document.getElementById(prefix));
        return prefix;
      },
      getSelectorFromElement: function getSelectorFromElement(element) {
        var selector = element.getAttribute('data-target');
        if (!selector || selector === '#') {
          selector = element.getAttribute('href') || '';
        }

        // If it's an ID
        if (selector.charAt(0) === '#') {
          selector = escapeId(selector);
        }

        try {
          var $selector = $$$1(document).find(selector);
          return $selector.length > 0 ? selector : null;
        } catch (err) {
          return null;
        }
      },
      reflow: function reflow(element) {
        return element.offsetHeight;
      },
      triggerTransitionEnd: function triggerTransitionEnd(element) {
        $$$1(element).trigger(transition.end);
      },
      supportsTransitionEnd: function supportsTransitionEnd() {
        return Boolean(transition);
      },
      isElement: function isElement(obj) {
        return (obj[0] || obj).nodeType;
      },
      typeCheckConfig: function typeCheckConfig(componentName, config, configTypes) {
        for (var property in configTypes) {
          if (Object.prototype.hasOwnProperty.call(configTypes, property)) {
            var expectedTypes = configTypes[property];
            var value = config[property];
            var valueType = value && Util.isElement(value) ? 'element' : toType(value);

            if (!new RegExp(expectedTypes).test(valueType)) {
              throw new Error(componentName.toUpperCase() + ': ' + ('Option "' + property + '" provided type "' + valueType + '" ') + ('but expected type "' + expectedTypes + '".'));
            }
          }
        }
      },


      // 根据模板解析 html 内容
      applyTemplate: function applyTemplate() {
        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        var template = args[0],
            values = args[1],
            _values = args.slice(2);

        var newValues = _extends({}, values);

        _values.forEach(function (item) {
          Object.assign(newValues, item);
        });

        return template.replace(tmplRe, function (m, name) {
          return newValues[name] !== undefined ? newValues[name] : '';
        });
      }
    };

    setTransitionEndSupport();

    return Util;
  }($);

  var _typeof$3 = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

  var _extends$1 = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

  var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

  function _classCallCheck$4(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  // Select 组件
  var Select = function ($$$1) {

    var NAME = 'select';
    var DATA_KEY = 'fuc.select';
    var EVENT_KEY = '.' + DATA_KEY;
    var DATA_API_KEY = '.data-api';
    var JQUERY_NO_CONFLICT = $$$1.fn[NAME];
    var ESCAPE_KEYCODE = 27; // KeyboardEvent.which value for Escape (Esc) key
    var SPACE_KEYCODE = 32; // KeyboardEvent.which value for space key
    var TAB_KEYCODE = 9; // KeyboardEvent.which value for tab key
    var ARROW_UP_KEYCODE = 38; // KeyboardEvent.which value for up arrow key
    var ARROW_DOWN_KEYCODE = 40; // KeyboardEvent.which value for down arrow key
    var RIGHT_MOUSE_BUTTON_WHICH = 3; // MouseEvent.which value for the right button (assuming a right-handed mouse)
    var REGEXP_KEYDOWN = new RegExp(ARROW_UP_KEYCODE + '|' + ARROW_DOWN_KEYCODE + '|' + ESCAPE_KEYCODE);

    // 事件
    var Event = {
      HIDE: 'hide' + EVENT_KEY,
      HIDDEN: 'hidden' + EVENT_KEY,
      SHOW: 'show' + EVENT_KEY,
      SHOWN: 'shown' + EVENT_KEY,
      SELECTED: 'selected' + EVENT_KEY,
      CLICK: 'click' + EVENT_KEY,
      CLICK_DATA_API: 'click' + EVENT_KEY + DATA_API_KEY,
      KEYDOWN_DATA_API: 'keydown' + EVENT_KEY + DATA_API_KEY,
      KEYUP_DATA_API: 'keyup' + EVENT_KEY + DATA_API_KEY
    };

    // 相关样式
    var ClassName = {
      OPTIONS: 'fuc-select-options',
      OPTION: 'fuc-select-option',
      TEXT: 'fuc-select-text',
      DISABLED: 'disabled',
      SELECT_ACTIVE: 'fuc-select-active',
      ACTIVE: 'active',
      EXPANDED: 'expanded',
      SHOW: 'show',
      DROPUP: 'dropup',
      DROPRIGHT: 'dropright',
      DROPLEFT: 'dropleft',
      MENURIGHT: 'dropdown-options-right',
      MENULEFT: 'dropdown-options-left',
      POSITION_STATIC: 'position-static'
    };

    var Selector = {
      SELECT: '.fuc-select',
      OPTIONS: '.fuc-select-options',
      OPTION: '.fuc-select-option',
      EXPANDED: '.expanded',
      TEXT: '.fuc-select-text',
      INPUT: '.fuc-select-title > input',
      SELECT_ACTIVE: '.fuc-select-active',
      ACTIVE: '.active',
      DATA_TOGGLE: '[data-toggle="select"]',
      ARIA_LEVEL: '[aria-level="branch"]'
    };

    var Default = {
      offset: 0,
      flip: true,
      boundary: 'scrollParent'
    };

    var DefaultType = {
      offset: '(number|string|function)',
      flip: 'boolean',
      boundary: '(string|element)'
    };

    // 生成下拉选项的模板
    var Templates = {
      options: '<ul class="' + ClassName.OPTIONS + '">{{:options}}</ul>',
      option: '<li class="' + ClassName.OPTION + '{{:selected}}" data-value="{{:value}}">\n              <a class="' + ClassName.TEXT + '" href="#">{{:text}}</a>\n            </li>',
      optionBranch: '<li class="' + ClassName.OPTION + '{{:selected}}" data-value="{{:value}}" aria-level="branch">\n              <a class="' + ClassName.TEXT + '" href="#">{{:text}}</a>\n              {{:childrenEl}}\n            </li>'
    };

    var Select = function () {
      function Select(element, config) {
        _classCallCheck$4(this, Select);

        this._element = element;
        this._config = this._getConfig(config);
        this._values = null; // 当前选中的值
        this._texts = null; // 当前选中的文本
        // select options
        this._options = this._getOptionsElement();
        // input 输入框
        this._input = $$$1(this._element).find(Selector.INPUT);

        // 是否是多级菜单
        this.multistage = this._config.multistage;

        // 初始化数据
        this.setOptionsData();

        this._addEventListeners();
      }

      // Getters


      Select.prototype._renderOptions = function _renderOptions(options) {
        var _this = this;

        return options.map(function (item) {
          var children = item.children,
              selected = item.selected,
              value = item.value,
              text = item.text;

          if (children && children.length > 0) {
            // 叶子节点
            var childrenEl = Util.applyTemplate(Templates.options, {
              options: _this._renderOptions(children)
            });

            return Util.applyTemplate(Templates.optionBranch, {
              childrenEl: childrenEl,
              value: value,
              text: text
            });
          }

          return Util.applyTemplate(Templates.option, {
            value: value,
            text: text,
            selected: selected ? ' ' + ClassName.ACTIVE : ''
          });
        }).join('');
      };

      // Public

      Select.prototype.setOptionsData = function setOptionsData(data) {
        /**
         * optionsData 数据格式为
         [{
           value: 'value1',
           text: 'text1'
         }, {
           value: 'value2',
           text: 'text2',
           selected: true
         }, {
           value: 'value3',
           text: 'text3'
         }]
         */
        if (data) {
          this._config.optionsData = data;
        }
        var optionsData = this._config.optionsData;

        if (optionsData && optionsData.length > 0) {
          this.render();
        } else {
          // 设置活动的 item
          this._setActiveItems();
        }
      };

      // 清空 select options


      Select.prototype.clear = function clear() {
        $$$1(this._options).empty();
        this._config.optionsData = null;
        this._values = null; // 当前选中的值
        this._texts = null; // 当前选中的文本
        this._input.val('');
      };

      // 渲染组件


      Select.prototype.render = function render() {
        var _config2 = this._config,
            optionsData = _config2.optionsData,
            multistage = _config2.multistage;

        var html = null;

        // 如果是多级选择
        if (multistage) {
          html = this._renderOptions(optionsData);
        } else {
          html = optionsData.map(function (item) {
            var _item = _extends$1({}, item);
            if (_item.selected) {
              _item.selected = ' ' + ClassName.ACTIVE;
            }
            return Util.applyTemplate(Templates.option, _item);
          });
        }

        $$$1(this._options).html(html);
        this._setActiveItems();
      };

      // 这里使用回调函数把数据返回


      Select.prototype.getSelectedOption = function getSelectedOption() {
        var value = this.multistage ? this._values : this._values[this._values.length - 1];
        var text = this.multistage ? this._texts : this._texts[this._texts.length - 1];

        return {
          value: value,
          text: value ? text : '',
          selectedOption: this.previousActiveItems
        };
      };

      // 显示或隐藏下拉菜单


      Select.prototype.toggle = function toggle() {
        // 清空其他已打开的 select
        Select._clearOptions();

        if (this._element.disabled || $$$1(this._element).hasClass(ClassName.DISABLED)) {
          return;
        }

        // 如果下拉选项为 0 时，则返回
        if ($$$1(this._options).length === 0 || $$$1(this._options).find(Selector.OPTION).length === 0) {
          return;
        }

        var $element = $$$1(this._element);
        var isActive = $element.hasClass(ClassName.SELECT_ACTIVE);

        if (isActive) {
          return;
        }

        var relatedTarget = {
          relatedTarget: this._element
        };
        var showEvent = $$$1.Event(Event.SHOW, relatedTarget);

        $element.trigger(showEvent);

        if (showEvent.isDefaultPrevented()) {
          return;
        }

        this._element.focus();
        this._element.setAttribute('aria-expanded', true);

        // 显示下拉框
        $element.toggleClass(ClassName.SELECT_ACTIVE).trigger($$$1.Event(Event.SHOWN, relatedTarget));
      };

      // Private

      Select.prototype._addEventListeners = function _addEventListeners() {
        var _this2 = this;

        // 展开事件
        $$$1(this._element).on(Event.CLICK, function (event) {
          event.preventDefault();
          event.stopPropagation();
          _this2.toggle();
        });

        // 选中某一 Option
        $$$1(this._element).on(Event.CLICK, Selector.OPTION, function (event) {
          event.preventDefault();
          event.stopPropagation();

          var currentTarget = event.currentTarget;

          var $el = $$$1(currentTarget);
          if ($el.hasClass(ClassName.DISABLED) || $el.attr(ClassName.DISABLED) !== undefined) {
            return;
          }

          var ariaLevel = $el.attr('aria-level');
          if (ariaLevel === 'branch') {
            $el.parent().find(Selector.OPTION + ' > ' + Selector.OPTIONS).removeClass(ClassName.EXPANDED);
            var $options = $el.find('> ' + Selector.OPTIONS);
            $options.addClass(ClassName.EXPANDED);

            // 处理碰壁
            var offset = $el.offset();
            var left = offset.left;

            var width = $options.outerWidth();
            var _window = window,
                innerWidth = _window.innerWidth;

            if (left + $el.outerWidth() + width + 10 > innerWidth) {
              $el.addClass('direction-rl');
            } else {
              $el.removeClass('direction-rl');
            }
          } else {
            _this2._setActiveItems($el);
            _this2._hideSelect();
          }
        });
      };

      // 设置当前选中的元素，目前不支持多选，后续补上，还成数组即可


      Select.prototype._setActiveItems = function _setActiveItems($el) {
        if (this.previousActiveItems) {
          this.previousActiveItems.forEach(function (el) {
            $$$1(el).removeClass(ClassName.ACTIVE);
          });
        }

        if (!$el) {
          $el = $$$1(this._element).find(Selector.OPTION + Selector.ACTIVE + ':not(' + Selector.ARIA_LEVEL + ')');
        }

        if ($el.length === 0) {
          return;
        }

        $el.addClass(ClassName.ACTIVE);

        this.previousActiveItems = [];

        this.previousActiveItems.push($el);
        var parentNode = $el.parent().parent(Selector.OPTION);

        // 分支节点也设置 ACTIVE
        while (parentNode && parentNode.length === 1) {
          parentNode.addClass(ClassName.ACTIVE);
          this.previousActiveItems.unshift(parentNode);
          parentNode = parentNode.parent().parent(Selector.OPTION);
        }

        var values = [];
        var texts = [];
        this.previousActiveItems.forEach(function (item) {
          values.push(item.data('value'));
          texts.push(item.find('> ' + Selector.TEXT).text());
        });

        this._texts = texts;
        this._values = values;

        if (values[values.length - 1]) {
          this._input.val(texts[texts.length - 1]);
        } else {
          this._input.val('');
        }
      };

      // 返回 config


      Select.prototype._getConfig = function _getConfig(config) {
        config = _extends$1({}, this.constructor.Default, $$$1(this._element).data(), config);

        Util.typeCheckConfig(NAME, config, this.constructor.DefaultType);

        return config;
      };

      Select.prototype._getOptionsElement = function _getOptionsElement() {
        if (!this._options) {
          var options = $$$1(this._element).find(Selector.OPTIONS);
          if (options && options.length > 0) {
            this._options = options[0];
          } else {
            this._options = $$$1('<ul class="' + ClassName.OPTIONS + '"/>').appendTo(this._element)[0];
          }
        }
        return this._options;
      };

      // 隐藏 select


      Select.prototype._hideSelect = function _hideSelect() {
        // 如果是多选的话
        this._updateClass();

        var value = this.multistage ? this._values : this._values[this._values.length - 1];
        var text = this.multistage ? this._texts : this._texts[this._texts.length - 1];

        $$$1(this._element).removeClass(ClassName.SELECT_ACTIVE).trigger($$$1.Event(Event.SELECTED, {
          relatedTarget: this._element,
          value: value,
          text: value ? text : ''
        }));
      };

      Select.prototype._updateClass = function _updateClass() {
        // 如果是多选的话
        if (this.multistage) {
          // 去掉已经展开的样式
          $$$1(this._element).find(Selector.OPTIONS + Selector.EXPANDED).removeClass(ClassName.EXPANDED);
          // 去掉已经改变位置的样式
          $$$1(this._element).find(Selector.DIRECTION_RL).removeClass(ClassName.DIRECTION_RL);
        }
      };

      // Static

      Select._jQueryInterface = function _jQueryInterface(config, params) {
        // 处理单个 select 时，注意这里 this 是一个 jquery 对象
        if (this.length === 1 && config === 'getSelectedOption') {
          var data = this.data(DATA_KEY);

          if (!data) {
            data = new Select(this[0]);
            this.data(DATA_KEY, data);
          }

          return data[config]();
        }

        return this.each(function () {
          var data = $$$1(this).data(DATA_KEY);
          var _config = (typeof config === 'undefined' ? 'undefined' : _typeof$3(config)) === 'object' ? config : null;

          if (!data) {
            data = new Select(this, _config);
            $$$1(this).data(DATA_KEY, data);
          }

          if (typeof config === 'string') {
            if (typeof data[config] === 'undefined') {
              throw new TypeError('No method named "' + config + '"');
            }
            if (params) {
              data[config](params);
            } else {
              data[config]();
            }
          }
        });
      };

      // 关闭其他 select


      Select._clearOptions = function _clearOptions(event) {
        // 过滤掉一些按键和鼠标右键
        if (event && (event.which === RIGHT_MOUSE_BUTTON_WHICH || event.type === 'keyup' && event.which !== TAB_KEYCODE)) {
          return;
        }

        var selects = $$$1.makeArray($$$1(Selector.SELECT));
        for (var i = 0; i < selects.length; i++) {
          var $select = $$$1(selects[i]);
          var context = $select.data(DATA_KEY);
          var relatedTarget = {
            relatedTarget: selects[i]
          };

          if (!context) {
            continue;
          }

          if (!$select.hasClass(ClassName.SELECT_ACTIVE)) {
            continue;
          }

          if (event && (event.type === 'click' && /input|textarea/i.test(event.target.tagName) || event.type === 'keyup' && event.which === TAB_KEYCODE) && $$$1.contains($select, event.target)) {
            continue;
          }

          var hideEvent = $$$1.Event(Event.HIDE, relatedTarget);
          $select.trigger(hideEvent);
          if (hideEvent.isDefaultPrevented()) {
            continue;
          }

          selects[i].setAttribute('aria-expanded', 'false');

          context._updateClass();

          $select.removeClass(ClassName.SELECT_ACTIVE).trigger($$$1.Event(Event.HIDDEN, relatedTarget));
        }
      };

      Select._getParentFromElement = function _getParentFromElement(element) {
        var parent = void 0;
        var selector = Util.getSelectorFromElement(element);

        if (selector) {
          parent = $$$1(selector)[0];
        }

        return parent || element.parentNode;
      };

      // eslint-disable-next-line complexity


      Select._dataApiKeydownHandler = function _dataApiKeydownHandler(event) {
        if (/input|textarea/i.test(event.target.tagName) ? event.which === SPACE_KEYCODE || event.which !== ESCAPE_KEYCODE && (event.which !== ARROW_DOWN_KEYCODE && event.which !== ARROW_UP_KEYCODE || $$$1(event.target).closest(Selector.MENU).length) : !REGEXP_KEYDOWN.test(event.which)) {
          return;
        }

        event.preventDefault();
        event.stopPropagation();

        if (this.disabled || $$$1(this).hasClass(ClassName.DISABLED)) {
          return;
        }

        var parent = Select._getParentFromElement(this);
        var isActive = $$$1(parent).hasClass(ClassName.SHOW);

        if (!isActive && (event.which !== ESCAPE_KEYCODE || event.which !== SPACE_KEYCODE) || isActive && (event.which === ESCAPE_KEYCODE || event.which === SPACE_KEYCODE)) {
          if (event.which === ESCAPE_KEYCODE) {
            var toggle = $$$1(parent).find(Selector.DATA_TOGGLE)[0];
            $$$1(toggle).trigger('focus');
          }

          $$$1(this).trigger('click');
          return;
        }

        var items = $$$1(parent).find(Selector.VISIBLE_ITEMS).get();

        if (items.length === 0) {
          return;
        }

        var index = items.indexOf(event.target);

        if (event.which === ARROW_UP_KEYCODE && index > 0) {
          // Up
          index--;
        }

        if (event.which === ARROW_DOWN_KEYCODE && index < items.length - 1) {
          // Down
          index++;
        }

        if (index < 0) {
          index = 0;
        }

        items[index].focus();
      };

      _createClass(Select, null, [{
        key: 'Default',
        get: function get() {
          return Default;
        }
      }, {
        key: 'DefaultType',
        get: function get() {
          return DefaultType;
        }
      }]);

      return Select;
    }();

    /**
     * ------------------------------------------------------------------------
     * Data Api implementation
     * ------------------------------------------------------------------------
     */

    $$$1(document)
    //.on(Event.KEYDOWN_DATA_API, Selector.DATA_TOGGLE, Select._dataApiKeydownHandler)
    //.on(Event.KEYDOWN_DATA_API, Selector.MENU, Select._dataApiKeydownHandler)
    .on(Event.CLICK_DATA_API + ' ' + Event.KEYUP_DATA_API, Select._clearOptions).on(Event.CLICK_DATA_API, Selector.DATA_TOGGLE, function (event) {
      event.preventDefault();
      event.stopPropagation();
      Select._jQueryInterface.call($$$1(this), 'toggle');
    });

    /**
     * ------------------------------------------------------------------------
     * jQuery
     * ------------------------------------------------------------------------
     */

    $$$1.fn[NAME] = Select._jQueryInterface;
    $$$1.fn[NAME].Constructor = Select;
    $$$1.fn[NAME].noConflict = function () {
      $$$1.fn[NAME] = JQUERY_NO_CONFLICT;
      return Select._jQueryInterface;
    };

    return Select;
  }($);

  // import './slider.scss'

  var slider = function ($$$1) {}($);

  var _typeof$4 = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

  var _extends$2 = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

  function _classCallCheck$5(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  var re = /{{([\w-]+)}}/g;

  /**
   * 把字符串模板转换为字符串，比如
   * applyTemplate('<div class="{{className}}">{{text}}</div>', {className: 'paging', text: '页码'})
   * 结果为 <div class="paging">页码</div>
   * @param template
   * @param values
   * @returns {*}
   */
  function applyTemplate(template, values) {
    return template.replace(re, function (m, name) {
      return values[name] !== undefined ? values[name] : '';
    });
  }

  // 改变选项时，是否重新渲染
  var reloadOption = ['totalCount', 'totalPages', 'pageNum', 'pageSize', 'rowList', 'condition', 'jsonReader'];

  var Paging = function ($$$1) {
    var NAME = 'paging';
    var DATA_KEY = 'fuc.paging';
    var EVENT_KEY = '.' + DATA_KEY;
    var DATA_API_KEY = '.data-api';
    var JQUERY_NO_CONFLICT = $$$1.fn[NAME];

    var ClassName = {
      PAGING_ITEM: 'paging-item',
      DISABLED: 'disabled',
      ACTIVE: 'active'
    };

    var Event = {
      CLICK_DATA_API: 'click' + EVENT_KEY + DATA_API_KEY,
      CHANGE_DATA_API: 'change' + EVENT_KEY + DATA_API_KEY
    };

    var Paging = function () {
      function Paging(element, config) {
        var _this = this;

        _classCallCheck$5(this, Paging);

        this._handleSwitchPage = function (evt) {
          evt.preventDefault();
          var currentTarget = evt.currentTarget;

          var pageNum = parseInt($$$1(currentTarget).parent().data('pagenum'), 10);
          _this._handleChangePage(pageNum);
        };

        this._handleJumpPage = function (evt) {
          evt.preventDefault();
          var $input = $$$1(_this.element).find('.js-jump-input');
          var pageNum = parseInt($input.val(), 10);
          if (!Number.isNaN(pageNum)) {
            _this._handleChangePage(pageNum);
          }
        };

        this._handleChangePerPage = function (evt) {
          var value = evt.value;


          var pageSize = parseInt(value, 10);
          _this.pageSize = pageSize;
          _this._loadData();
        };

        this.element = element;
        var _config = _extends$2({}, Paging.defaultConfig, config);
        // 设置 config 到 this 上
        Object.keys(_config).forEach(function (key) {
          _this[key] = _config[key];
        });

        this._loadData();
        this._addEventListeners();
      }

      // 设置监听事件

      /**
       * pagingControl 控制是否显示页码、总记录数、切换每页条数和跳转至某一页 {Boolean}
       * recordPerPage 是否显示【切换每页条数】{Boolean}
       * jumpControl 是否显示跳转至某一页 {Boolean}
       * @type {{pagingControl: boolean, recordPerPage: boolean, jumpControl: boolean}}
       */


      Paging.prototype._addEventListeners = function _addEventListeners() {
        // 监听页码切换事件
        $$$1(this.element).on(Event.CLICK_DATA_API, '.fuc-pagination li a', this._handleSwitchPage);
        // 监听跳转到第几页事件
        $$$1(this.element).on(Event.CLICK_DATA_API, '.js-jump-btn', this._handleJumpPage);
      };

      /**
       * 页码切换事件
       * @param evt
       * @private
       */


      /**
       * 跳转到第几页事件
       * @param evt
       * @private
       */


      /**
       * 改变每页显示多少条记录事件
       * @param evt
       * @private
       */


      /**
       * 改变页码公共方法
       * @param pageNum
       * @private
       */
      Paging.prototype._handleChangePage = function _handleChangePage(pageNum) {
        if (this.totalPages === 1) {
          return;
        }
        if (pageNum <= 1) {
          pageNum = 1;
        }

        if (pageNum >= this.totalPages) {
          pageNum = this.totalPages;
        }

        this.pageNum = pageNum;
        this._loadData();
      };

      /**
       * 加载分页数据方法
       * @private
       */


      Paging.prototype._loadData = function _loadData() {
        var _this2 = this;

        var loadPageData = this.loadPageData,
            pageSize = this.pageSize,
            pageNum = this.pageNum,
            jsonReader = this.jsonReader;

        // 渲染数据

        if (loadPageData && typeof loadPageData === 'function') {
          if (this.isRenderPagingBeforData) {
            this._renderPaging();
          }

          loadPageData({
            pageNum: pageNum,
            pageSize: pageSize,
            condition: this.condition || {},
            callback: function callback(data) {
              _this2.totalPages = data[jsonReader.totalPages];
              _this2.totalCount = data[jsonReader.totalCount];
              _this2._renderPaging();
            }
          });
        } else {
          this._renderPaging();
        }
      };

      /**
       * 渲染分页 dom 元素
       * @private
       */


      Paging.prototype._renderPaging = function _renderPaging() {
        var _this3 = this;

        var pageArray = this._calculatePage();
        var pagingDirection = this.pagingControlTmpl.pagingDirection;


        var html = '<ul class="fuc-pagination fuc-pagination-control">';
        html += '<li class="' + (this.pageNum === 1 ? '' + ClassName.DISABLED : '') + '" data-pagenum="' + (this.pageNum - 1) + '">' + (this.pageNum === 1 ? '<span>上一页</span>' : '<a href="#">上一页</a>') + '</li>';
        var pageItems = pageArray.map(function (item, index) {
          if (item === '...') {
            return '<li class="fuc-paging-more"><span>...</span></li>';
          }
          return '<li class="' + (_this3.pageNum === item ? '' + ClassName.ACTIVE : '') + '" data-pagenum="' + item + '">' + (_this3.pageNum === item ? '<span>' + item + '</span>' : '<a href="#">' + item + '</a>') + '</li>';
        });
        html += pageItems.join('');
        /*eslint-disable max-len*/
        html += '<li class="' + (this.pageNum === this.totalPages ? '' + ClassName.DISABLED : '') + '" data-pagenum="' + (this.pageNum + 1) + '">' + (this.pageNum === this.totalPages ? '<span>下一页</span>' : '<a href="#">下一页</a>') + '</li>';
        html += '</ul>';

        if (this.pagingControl) {
          html += this._renderPagingControl();
        }

        html = applyTemplate(pagingDirection, {
          direction: this.direction,
          pagingItems: html
        });

        $$$1(this.element).html(html);

        // 注册 select 事件
        $$$1(this.element).find('[data-toggle="select"]').select().on('selected.fuc.select', this._handleChangePerPage);
      };

      /**
       * 渲染页面每页显示多少条和跳至第一页 dom 元素
       * @returns {*|Array}
       * @private
       */


      Paging.prototype._renderPagingControl = function _renderPagingControl() {
        var _this4 = this;

        var _pagingControlTmpl = this.pagingControlTmpl,
            controlPanel = _pagingControlTmpl.controlPanel,
            recordHtml = _pagingControlTmpl.recordHtml,
            recordPerPage = _pagingControlTmpl.recordPerPage,
            jumpControl = _pagingControlTmpl.jumpControl;


        var pageHtml = [];

        if (this.records) {
          pageHtml.push(applyTemplate(recordHtml, {
            totalPages: this.totalPages,
            totalCount: this.totalCount
          }));
        }

        if (this.recordPerPage) {
          pageHtml.push(applyTemplate(recordPerPage, {
            selectOptions: this.rowList.map(function (item) {
              return '<li class="fuc-select-option' + (_this4.pageSize === item ? ' active' : '') + '" data-value="' + item + '">\n                    <a class="fuc-select-text" href="#">' + item + '\u6761/\u9875</a>\n              </li>';
            }).join('')
          }));
        }

        if (this.jumpControl) {
          pageHtml.push(applyTemplate(jumpControl, {
            jumpInputValue: this.pageNum
          }));
        }

        pageHtml = pageHtml.join(pageHtml.length > 1 ? this.separator : '');

        pageHtml = applyTemplate(controlPanel, {
          controlPanel: pageHtml
        });

        return pageHtml;
      };

      /**
       * 计算页码显示算法，返回一个页码数组
       * @returns {Array}
       */


      Paging.prototype._calculatePage = function _calculatePage() {
        var totalPages = this.totalPages;
        var pageNum = this.pageNum;

        var pageArray = [];
        if (totalPages < 8) {
          for (var i = 1; i <= totalPages; i++) {
            pageArray.push(i);
          }
        } else {
          pageArray.push(1);
          if (pageNum > 4) {
            pageArray.push('...');
          }

          if (pageNum < 4) {
            for (var _i = 2; _i <= 6; _i++) {
              pageArray.push(_i);
            }
          } else if (pageNum >= 4 && totalPages - pageNum >= 3) {
            for (var _i2 = pageNum - 2; _i2 <= pageNum + 2; _i2++) {
              pageArray.push(_i2);
            }
          } else {
            for (var _i3 = totalPages - 4; _i3 < totalPages; _i3++) {
              pageArray.push(_i3);
            }
          }

          //总页码 - 当前页 大于 3 显示
          if (totalPages - pageNum > 3) {
            pageArray.push('...');
          }
          pageArray.push(totalPages);
        }

        return pageArray;
      };

      // Public

      /**
       * 重新渲染分页
       * @param condition
       * @param resetFirstPageNum 是否重置为第一页
       */


      Paging.prototype.reload = function reload(condition) {
        var resetFirstPageNum = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

        this.condition = _extends$2({}, condition);
        if (resetFirstPageNum) {
          this.pageNum = 1;
        } else if (condition.pageNum !== undefined) {
          this.pageNum = condition.pageNum;
          delete this.condition.pageNum;
        }

        this._loadData();
      };

      /**
       * 动态修改配置项
       * @param options {object}
       */


      Paging.prototype.setOptions = function setOptions(options) {
        var _this5 = this;

        if ((typeof options === 'undefined' ? 'undefined' : _typeof$4(options)) !== 'object') {
          throw new TypeError('The params options should be an object');
        }
        var isReload = false;
        // 设置 options 到 this 上
        Object.keys(options).forEach(function (key) {
          _this5[key] = options[key];
          if (reloadOption.indexOf(key) !== -1) {
            isReload = true;
          }
        });
        if (isReload) {
          this._loadData();
        } else {
          this._renderPaging();
        }
      };

      // Static


      Paging._jQueryInterface = function _jQueryInterface(config) {
        for (var _len = arguments.length, params = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          params[_key - 1] = arguments[_key];
        }

        return this.each(function () {
          var data = $$$1(this).data(DATA_KEY);

          if (!data) {
            data = new Paging(this, config);
            $$$1(this).data(DATA_KEY, data);
          }

          if (typeof config === 'string') {
            var _data;

            if (typeof data[config] === 'undefined') {
              throw new TypeError('No method named "' + config + '"');
            }
            (_data = data)[config].apply(_data, params);
          }
        });
      };

      return Paging;
    }();

    /**
     * ------------------------------------------------------------------------
     * jQuery
     * ------------------------------------------------------------------------
     */

    Paging.defaultConfig = {
      pagingControl: true, // 控制是否显示页码、总记录数、切换每页条数和跳转至某一页
      records: true, // 是否显示页码和记录数
      recordPerPage: true, // 是否显示【切换每页条数】
      jumpControl: true, // 是否显示跳转至某一页
      isRenderPagingBeforData: true, // 是否在加载数据之前渲染分页
      direction: 'right', // 默认右对齐
      totalCount: 0, // 总记录数
      totalPages: 0, // 总页码 | 如果设置了loadPageData，不用传，直接取后台返回的 totalPages 即可
      pageNum: 1, // 当前第几页
      pageSize: 10, // 每页显示的记录数
      rowList: [5, 10, 20, 50, 100], // 可切换每页显示页码列表值
      condition: {}, // 数据请求条件
      jsonReader: { // 后台返回数据格式对应字段
        items: 'items',
        pageNum: 'pageNum',
        totalPages: 'totalPages',
        totalCount: 'totalCount'
      },
      pagingControlTmpl: { // 分页渲染页码、总记录数、切换分页条数模板
        pagingDirection: '<div class="fuc-paging-{{direction}}">{{pagingItems}}</div>',
        controlPanel: '<ul class="fuc-paging-control">{{controlPanel}}</ul>',
        recordHtml: '<li class="fuc-paging-control-item">共{{totalPages}}页{{totalCount}}条记录</li>',
        recordPerPage: '<li class="fuc-paging-control-item">\n            <div class="fuc-select" data-toggle="select">\n              <div class="fuc-select-title">\n                <input type="text"/>\n              </div>\n              <ul class="fuc-select-options">\n                {{selectOptions}}\n              </ul>\n            </div></li>',
        jumpControl: '<li class="fuc-paging-control-item">\n          \u8DF3\u81F3\n          <div class="fuc-input-inline input">\n            <div class="fuc-input-group">\n              <input type="text" class="fuc-input-control js-jump-input" value="{{jumpInputValue}}"/>\n            </div>\n          </div>\n          \u9875\n          <button class="fuc-btn fuc-m-l-1 primary js-jump-btn">\u786E\u5B9A</button>\n        </li>'
      },
      separator: '' // 显示页码总记录数、切换每页条数和跳转至某一页中间分隔符
    };
    $$$1.fn[NAME] = Paging._jQueryInterface;
    $$$1.fn[NAME].Constructor = Paging;
    $$$1.fn[NAME].noConflict = function () {
      $$$1.fn[NAME] = JQUERY_NO_CONFLICT;
      return Paging._jQueryInterface;
    };

    return Paging;
  }($);

  var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

  function unwrapExports (x) {
  	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
  }

  function createCommonjsModule(fn, module) {
  	return module = { exports: {} }, fn(module, module.exports), module.exports;
  }

  var _switch = createCommonjsModule(function (module, exports) {
  /**
   * bootstrap-switch - Turn checkboxes and radio buttons into toggle switches.
   *
   * @version v3.3.4
   * @homepage https://bttstrp.github.io/bootstrap-switch
   * @author Mattia Larentis <mattia@larentis.eu> (http://larentis.eu)
   * @license Apache-2.0
   */

  (function (global, factory) {
      if (typeof undefined === "function" && undefined.amd) {
          undefined(['jquery'], factory);
      } else {
          factory($);
      }
  })(commonjsGlobal, function (_jquery) {

      var _jquery2 = _interopRequireDefault(_jquery);

      function _interopRequireDefault(obj) {
          return obj && obj.__esModule ? obj : {
              default: obj
          };
      }

      var _extends = Object.assign || function (target) {
          for (var i = 1; i < arguments.length; i++) {
              var source = arguments[i];

              for (var key in source) {
                  if (Object.prototype.hasOwnProperty.call(source, key)) {
                      target[key] = source[key];
                  }
              }
          }

          return target;
      };

      function _classCallCheck(instance, Constructor) {
          if (!(instance instanceof Constructor)) {
              throw new TypeError("Cannot call a class as a function");
          }
      }

      var _createClass = function () {
          function defineProperties(target, props) {
              for (var i = 0; i < props.length; i++) {
                  var descriptor = props[i];
                  descriptor.enumerable = descriptor.enumerable || false;
                  descriptor.configurable = true;
                  if ("value" in descriptor) descriptor.writable = true;
                  Object.defineProperty(target, descriptor.key, descriptor);
              }
          }

          return function (Constructor, protoProps, staticProps) {
              if (protoProps) defineProperties(Constructor.prototype, protoProps);
              if (staticProps) defineProperties(Constructor, staticProps);
              return Constructor;
          };
      }();

      var $$$1 = _jquery2.default || window.jQuery || window.$;

      var BootstrapSwitch = function () {
          function BootstrapSwitch(element) {
              var _this = this;

              var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

              _classCallCheck(this, BootstrapSwitch);

              this.$element = $$$1(element);
              this.options = $$$1.extend({}, $$$1.fn.bootstrapSwitch.defaults, this._getElementOptions(), options);
              this.prevOptions = {};
              this.$wrapper = $$$1('<div>', {
                  class: function _class() {
                      var classes = [];
                      classes.push(_this.options.state ? 'on' : 'off');
                      if (_this.options.size) {
                          classes.push(_this.options.size);
                      }
                      if (_this.options.disabled) {
                          classes.push('disabled');
                      }
                      if (_this.options.readonly) {
                          classes.push('readonly');
                      }
                      if (_this.options.indeterminate) {
                          classes.push('indeterminate');
                      }
                      if (_this.options.inverse) {
                          classes.push('inverse');
                      }
                      if (_this.$element.attr('id')) {
                          classes.push('id-' + _this.$element.attr('id'));
                      }
                      return classes.map(_this._getClass.bind(_this)).concat([_this.options.baseClass], _this._getClasses(_this.options.wrapperClass)).join(' ');
                  }
              });
              this.$container = $$$1('<div>', { class: this._getClass('container') });
              this.$on = $$$1('<span>', {
                  html: this.options.onText,
                  class: this._getClass('handle-on') + ' ' + this._getClass(this.options.onColor)
              });
              this.$off = $$$1('<span>', {
                  html: this.options.offText,
                  class: this._getClass('handle-off') + ' ' + this._getClass(this.options.offColor)
              });
              this.$label = $$$1('<span>', {
                  html: this.options.labelText,
                  class: this._getClass('label')
              });
              this.$element.on('init.bootstrapSwitch', this.options.onInit.bind(this, element));
              this.$element.on('switchChange.bootstrapSwitch', function () {
                  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                      args[_key] = arguments[_key];
                  }

                  if (_this.options.onSwitchChange.apply(element, args) === false) {
                      if (_this.$element.is(':radio')) {
                          $$$1('[name="' + _this.$element.attr('name') + '"]').trigger('previousState.bootstrapSwitch', true);
                      } else {
                          _this.$element.trigger('previousState.bootstrapSwitch', true);
                      }
                  }
              });

              this.$container = this.$element.wrap(this.$container).parent();
              this.$wrapper = this.$container.wrap(this.$wrapper).parent();
              this.$element.before(this.options.inverse ? this.$off : this.$on).before(this.$label).before(this.options.inverse ? this.$on : this.$off);

              if (this.options.indeterminate) {
                  this.$element.prop('indeterminate', true);
              }

              this._init();
              this._elementHandlers();
              this._handleHandlers();
              this._labelHandlers();
              this._formHandler();
              this._externalLabelHandler();
              this.$element.trigger('init.bootstrapSwitch', this.options.state);
          }

          _createClass(BootstrapSwitch, [{
              key: 'setPrevOptions',
              value: function setPrevOptions() {
                  this.prevOptions = _extends({}, this.options);
              }
          }, {
              key: 'state',
              value: function state(value, skip) {
                  if (typeof value === 'undefined') {
                      return this.options.state;
                  }
                  if (this.options.disabled || this.options.readonly || this.options.state && !this.options.radioAllOff && this.$element.is(':radio')) {
                      return this.$element;
                  }
                  if (this.$element.is(':radio')) {
                      $$$1('[name="' + this.$element.attr('name') + '"]').trigger('setPreviousOptions.bootstrapSwitch');
                  } else {
                      this.$element.trigger('setPreviousOptions.bootstrapSwitch');
                  }
                  if (this.options.indeterminate) {
                      this.indeterminate(false);
                  }
                  this.$element.prop('checked', Boolean(value)).trigger('change.bootstrapSwitch', skip);
                  return this.$element;
              }
          }, {
              key: 'toggleState',
              value: function toggleState(skip) {
                  if (this.options.disabled || this.options.readonly) {
                      return this.$element;
                  }
                  if (this.options.indeterminate) {
                      this.indeterminate(false);
                      return this.state(true);
                  } else {
                      return this.$element.prop('checked', !this.options.state).trigger('change.bootstrapSwitch', skip);
                  }
              }
          }, {
              key: 'size',
              value: function size(value) {
                  if (typeof value === 'undefined') {
                      return this.options.size;
                  }
                  if (this.options.size != null) {
                      this.$wrapper.removeClass(this._getClass(this.options.size));
                  }
                  if (value) {
                      this.$wrapper.addClass(this._getClass(value));
                  }
                  this._width();
                  this._containerPosition();
                  this.options.size = value;
                  return this.$element;
              }
          }, {
              key: 'animate',
              value: function animate(value) {
                  if (typeof value === 'undefined') {
                      return this.options.animate;
                  }
                  if (this.options.animate === Boolean(value)) {
                      return this.$element;
                  }
                  return this.toggleAnimate();
              }
          }, {
              key: 'toggleAnimate',
              value: function toggleAnimate() {
                  this.options.animate = !this.options.animate;
                  this.$wrapper.toggleClass(this._getClass('animate'));
                  return this.$element;
              }
          }, {
              key: 'disabled',
              value: function disabled(value) {
                  if (typeof value === 'undefined') {
                      return this.options.disabled;
                  }
                  if (this.options.disabled === Boolean(value)) {
                      return this.$element;
                  }
                  return this.toggleDisabled();
              }
          }, {
              key: 'toggleDisabled',
              value: function toggleDisabled() {
                  this.options.disabled = !this.options.disabled;
                  this.$element.prop('disabled', this.options.disabled);
                  this.$wrapper.toggleClass(this._getClass('disabled'));
                  return this.$element;
              }
          }, {
              key: 'readonly',
              value: function readonly(value) {
                  if (typeof value === 'undefined') {
                      return this.options.readonly;
                  }
                  if (this.options.readonly === Boolean(value)) {
                      return this.$element;
                  }
                  return this.toggleReadonly();
              }
          }, {
              key: 'toggleReadonly',
              value: function toggleReadonly() {
                  this.options.readonly = !this.options.readonly;
                  this.$element.prop('readonly', this.options.readonly);
                  this.$wrapper.toggleClass(this._getClass('readonly'));
                  return this.$element;
              }
          }, {
              key: 'indeterminate',
              value: function indeterminate(value) {
                  if (typeof value === 'undefined') {
                      return this.options.indeterminate;
                  }
                  if (this.options.indeterminate === Boolean(value)) {
                      return this.$element;
                  }
                  return this.toggleIndeterminate();
              }
          }, {
              key: 'toggleIndeterminate',
              value: function toggleIndeterminate() {
                  this.options.indeterminate = !this.options.indeterminate;
                  this.$element.prop('indeterminate', this.options.indeterminate);
                  this.$wrapper.toggleClass(this._getClass('indeterminate'));
                  this._containerPosition();
                  return this.$element;
              }
          }, {
              key: 'inverse',
              value: function inverse(value) {
                  if (typeof value === 'undefined') {
                      return this.options.inverse;
                  }
                  if (this.options.inverse === Boolean(value)) {
                      return this.$element;
                  }
                  return this.toggleInverse();
              }
          }, {
              key: 'toggleInverse',
              value: function toggleInverse() {
                  this.$wrapper.toggleClass(this._getClass('inverse'));
                  var $on = this.$on.clone(true);
                  var $off = this.$off.clone(true);
                  this.$on.replaceWith($off);
                  this.$off.replaceWith($on);
                  this.$on = $off;
                  this.$off = $on;
                  this.options.inverse = !this.options.inverse;
                  return this.$element;
              }
          }, {
              key: 'onColor',
              value: function onColor(value) {
                  if (typeof value === 'undefined') {
                      return this.options.onColor;
                  }
                  if (this.options.onColor) {
                      this.$on.removeClass(this._getClass(this.options.onColor));
                  }
                  this.$on.addClass(this._getClass(value));
                  this.options.onColor = value;
                  return this.$element;
              }
          }, {
              key: 'offColor',
              value: function offColor(value) {
                  if (typeof value === 'undefined') {
                      return this.options.offColor;
                  }
                  if (this.options.offColor) {
                      this.$off.removeClass(this._getClass(this.options.offColor));
                  }
                  this.$off.addClass(this._getClass(value));
                  this.options.offColor = value;
                  return this.$element;
              }
          }, {
              key: 'onText',
              value: function onText(value) {
                  if (typeof value === 'undefined') {
                      return this.options.onText;
                  }
                  this.$on.html(value);
                  this._width();
                  this._containerPosition();
                  this.options.onText = value;
                  return this.$element;
              }
          }, {
              key: 'offText',
              value: function offText(value) {
                  if (typeof value === 'undefined') {
                      return this.options.offText;
                  }
                  this.$off.html(value);
                  this._width();
                  this._containerPosition();
                  this.options.offText = value;
                  return this.$element;
              }
          }, {
              key: 'labelText',
              value: function labelText(value) {
                  if (typeof value === 'undefined') {
                      return this.options.labelText;
                  }
                  this.$label.html(value);
                  this._width();
                  this.options.labelText = value;
                  return this.$element;
              }
          }, {
              key: 'handleWidth',
              value: function handleWidth(value) {
                  if (typeof value === 'undefined') {
                      return this.options.handleWidth;
                  }
                  this.options.handleWidth = value;
                  this._width();
                  this._containerPosition();
                  return this.$element;
              }
          }, {
              key: 'labelWidth',
              value: function labelWidth(value) {
                  if (typeof value === 'undefined') {
                      return this.options.labelWidth;
                  }
                  this.options.labelWidth = value;
                  this._width();
                  this._containerPosition();
                  return this.$element;
              }
          }, {
              key: 'baseClass',
              value: function baseClass(value) {
                  return this.options.baseClass;
              }
          }, {
              key: 'wrapperClass',
              value: function wrapperClass(value) {
                  if (typeof value === 'undefined') {
                      return this.options.wrapperClass;
                  }
                  if (!value) {
                      value = $$$1.fn.bootstrapSwitch.defaults.wrapperClass;
                  }
                  this.$wrapper.removeClass(this._getClasses(this.options.wrapperClass).join(' '));
                  this.$wrapper.addClass(this._getClasses(value).join(' '));
                  this.options.wrapperClass = value;
                  return this.$element;
              }
          }, {
              key: 'radioAllOff',
              value: function radioAllOff(value) {
                  if (typeof value === 'undefined') {
                      return this.options.radioAllOff;
                  }
                  var val = Boolean(value);
                  if (this.options.radioAllOff === val) {
                      return this.$element;
                  }
                  this.options.radioAllOff = val;
                  return this.$element;
              }
          }, {
              key: 'onInit',
              value: function onInit(value) {
                  if (typeof value === 'undefined') {
                      return this.options.onInit;
                  }
                  if (!value) {
                      value = $$$1.fn.bootstrapSwitch.defaults.onInit;
                  }
                  this.options.onInit = value;
                  return this.$element;
              }
          }, {
              key: 'onSwitchChange',
              value: function onSwitchChange(value) {
                  if (typeof value === 'undefined') {
                      return this.options.onSwitchChange;
                  }
                  if (!value) {
                      value = $$$1.fn.bootstrapSwitch.defaults.onSwitchChange;
                  }
                  this.options.onSwitchChange = value;
                  return this.$element;
              }
          }, {
              key: 'destroy',
              value: function destroy() {
                  var $form = this.$element.closest('form');
                  if ($form.length) {
                      $form.off('reset.bootstrapSwitch').removeData('fuc-switch');
                  }
                  this.$container.children().not(this.$element).remove();
                  this.$element.unwrap().unwrap().off('.bootstrapSwitch').removeData('fuc-switch');
                  return this.$element;
              }
          }, {
              key: '_getElementOptions',
              value: function _getElementOptions() {
                  return {
                      state: this.$element.is(':checked'),
                      size: this.$element.data('size'),
                      animate: this.$element.data('animate'),
                      disabled: this.$element.is(':disabled'),
                      readonly: this.$element.is('[readonly]'),
                      indeterminate: this.$element.data('indeterminate'),
                      inverse: this.$element.data('inverse'),
                      radioAllOff: this.$element.data('radio-all-off'),
                      onColor: this.$element.data('on-color'),
                      offColor: this.$element.data('off-color'),
                      onText: this.$element.data('on-label'),
                      offText: this.$element.data('off-text'),
                      labelText: this.$element.data('label-text'),
                      handleWidth: this.$element.data('handle-width'),
                      labelWidth: this.$element.data('label-width'),
                      baseClass: this.$element.data('base-class'),
                      wrapperClass: this.$element.data('wrapper-class')
                  };
              }
          }, {
              key: '_width',
              value: function _width() {
                  var _this2 = this;

                  var $handles = this.$on.add(this.$off).add(this.$label).css('width', '');
                  var handleWidth = this.options.handleWidth === 'auto' ? Math.round(Math.max(this.$on.width(), this.$off.width())) : this.options.handleWidth;
                  $handles.width(handleWidth);
                  this.$label.width(function (index, width) {
                      if (_this2.options.labelWidth !== 'auto') {
                          return _this2.options.labelWidth;
                      }
                      if (width < handleWidth) {
                          return handleWidth;
                      }
                      return width;
                  });
                  this._handleWidth = this.$on.outerWidth();
                  this._labelWidth = this.$label.outerWidth();
                  this.$container.width(this._handleWidth * 2 + this._labelWidth);
                  return this.$wrapper.width(this._handleWidth + this._labelWidth);
              }
          }, {
              key: '_containerPosition',
              value: function _containerPosition() {
                  var _this3 = this;

                  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.options.state;

                  this.$container.css('margin-left', function () {
                      var values = [0, '-' + _this3._handleWidth + 'px'];
                      if (_this3.options.indeterminate) {
                          return '-' + _this3._handleWidth / 2 + 'px';
                      }
                      if (state) {
                          if (_this3.options.inverse) {
                              return values[1];
                          } else {
                              return values[0];
                          }
                      } else {
                          if (_this3.options.inverse) {
                              return values[0];
                          } else {
                              return values[1];
                          }
                      }
                  });
              }
          }, {
              key: '_init',
              value: function _init() {
                  var _this4 = this;

                  var init = function init() {
                      _this4.setPrevOptions();
                      _this4._width();
                      _this4._containerPosition();
                      setTimeout(function () {
                          if (_this4.options.animate) {
                              return _this4.$wrapper.addClass(_this4._getClass('animate'));
                          }
                      }, 50);
                  };
                  if (this.$wrapper.is(':visible')) {
                      init();
                      return;
                  }
                  var initInterval = window.setInterval(function () {
                      if (_this4.$wrapper.is(':visible')) {
                          init();
                          return window.clearInterval(initInterval);
                      }
                  }, 50);
              }
          }, {
              key: '_elementHandlers',
              value: function _elementHandlers() {
                  var _this5 = this;

                  return this.$element.on({
                      'setPreviousOptions.bootstrapSwitch': this.setPrevOptions.bind(this),

                      'previousState.bootstrapSwitch': function previousStateBootstrapSwitch() {
                          _this5.options = _this5.prevOptions;
                          if (_this5.options.indeterminate) {
                              _this5.$wrapper.addClass(_this5._getClass('indeterminate'));
                          }
                          _this5.$element.prop('checked', _this5.options.state).trigger('change.bootstrapSwitch', true);
                      },

                      'change.bootstrapSwitch': function changeBootstrapSwitch(event, skip) {
                          event.preventDefault();
                          event.stopImmediatePropagation();
                          var state = _this5.$element.is(':checked');
                          _this5._containerPosition(state);
                          if (state === _this5.options.state) {
                              return;
                          }
                          _this5.options.state = state;
                          _this5.$wrapper.toggleClass(_this5._getClass('off')).toggleClass(_this5._getClass('on'));
                          if (!skip) {
                              if (_this5.$element.is(':radio')) {
                                  $$$1('[name="' + _this5.$element.attr('name') + '"]').not(_this5.$element).prop('checked', false).trigger('change.bootstrapSwitch', true);
                              }
                              _this5.$element.trigger('switchChange.bootstrapSwitch', [state]);
                          }
                      },

                      'focus.bootstrapSwitch': function focusBootstrapSwitch(event) {
                          event.preventDefault();
                          _this5.$wrapper.addClass(_this5._getClass('focused'));
                      },

                      'blur.bootstrapSwitch': function blurBootstrapSwitch(event) {
                          event.preventDefault();
                          _this5.$wrapper.removeClass(_this5._getClass('focused'));
                      },

                      'keydown.bootstrapSwitch': function keydownBootstrapSwitch(event) {
                          if (!event.which || _this5.options.disabled || _this5.options.readonly) {
                              return;
                          }
                          if (event.which === 37 || event.which === 39) {
                              event.preventDefault();
                              event.stopImmediatePropagation();
                              _this5.state(event.which === 39);
                          }
                      }
                  });
              }
          }, {
              key: '_handleHandlers',
              value: function _handleHandlers() {
                  var _this6 = this;

                  this.$on.on('click.bootstrapSwitch', function (event) {
                      event.preventDefault();
                      event.stopPropagation();
                      _this6.state(false);
                      return _this6.$element.trigger('focus.bootstrapSwitch');
                  });
                  return this.$off.on('click.bootstrapSwitch', function (event) {
                      event.preventDefault();
                      event.stopPropagation();
                      _this6.state(true);
                      return _this6.$element.trigger('focus.bootstrapSwitch');
                  });
              }
          }, {
              key: '_labelHandlers',
              value: function _labelHandlers() {
                  var _this7 = this;

                  var handlers = {
                      click: function click(event) {
                          event.stopPropagation();
                      },

                      'mousedown.bootstrapSwitch touchstart.bootstrapSwitch': function mousedownBootstrapSwitchTouchstartBootstrapSwitch(event) {
                          if (_this7._dragStart || _this7.options.disabled || _this7.options.readonly) {
                              return;
                          }
                          event.preventDefault();
                          event.stopPropagation();
                          _this7._dragStart = (event.pageX || event.originalEvent.touches[0].pageX) - parseInt(_this7.$container.css('margin-left'), 10);
                          if (_this7.options.animate) {
                              _this7.$wrapper.removeClass(_this7._getClass('animate'));
                          }
                          _this7.$element.trigger('focus.bootstrapSwitch');
                      },

                      'mousemove.bootstrapSwitch touchmove.bootstrapSwitch': function mousemoveBootstrapSwitchTouchmoveBootstrapSwitch(event) {
                          if (_this7._dragStart == null) {
                              return;
                          }
                          var difference = (event.pageX || event.originalEvent.touches[0].pageX) - _this7._dragStart;
                          event.preventDefault();
                          if (difference < -_this7._handleWidth || difference > 0) {
                              return;
                          }
                          _this7._dragEnd = difference;
                          _this7.$container.css('margin-left', _this7._dragEnd + 'px');
                      },

                      'mouseup.bootstrapSwitch touchend.bootstrapSwitch': function mouseupBootstrapSwitchTouchendBootstrapSwitch(event) {
                          if (!_this7._dragStart) {
                              return;
                          }
                          event.preventDefault();
                          if (_this7.options.animate) {
                              _this7.$wrapper.addClass(_this7._getClass('animate'));
                          }
                          if (_this7._dragEnd) {
                              var state = _this7._dragEnd > -(_this7._handleWidth / 2);
                              _this7._dragEnd = false;
                              _this7.state(_this7.options.inverse ? !state : state);
                          } else {
                              _this7.state(!_this7.options.state);
                          }
                          _this7._dragStart = false;
                      },

                      'mouseleave.bootstrapSwitch': function mouseleaveBootstrapSwitch() {
                          _this7.$label.trigger('mouseup.bootstrapSwitch');
                      }
                  };
                  this.$label.on(handlers);
              }
          }, {
              key: '_externalLabelHandler',
              value: function _externalLabelHandler() {
                  var _this8 = this;

                  var $externalLabel = this.$element.closest('label');
                  $externalLabel.on('click', function (event) {
                      event.preventDefault();
                      event.stopImmediatePropagation();
                      if (event.target === $externalLabel[0]) {
                          _this8.toggleState();
                      }
                  });
              }
          }, {
              key: '_formHandler',
              value: function _formHandler() {
                  var $form = this.$element.closest('form');
                  if ($form.data('fuc-switch')) {
                      return;
                  }
                  $form.on('reset.bootstrapSwitch', function () {
                      window.setTimeout(function () {
                          $form.find('input').filter(function () {
                              return $$$1(this).data('fuc-switch');
                          }).each(function () {
                              return $$$1(this).bootstrapSwitch('state', this.checked);
                          });
                      }, 1);
                  }).data('fuc-switch', true);
              }
          }, {
              key: '_getClass',
              value: function _getClass(name) {
                  return this.options.baseClass + '-' + name;
              }
          }, {
              key: '_getClasses',
              value: function _getClasses(classes) {
                  if (!$$$1.isArray(classes)) {
                      return [this._getClass(classes)];
                  }
                  return classes.map(this._getClass.bind(this));
              }
          }]);

          return BootstrapSwitch;
      }();

      $$$1.fn.bootstrapSwitch = function (option) {
          for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
              args[_key2 - 1] = arguments[_key2];
          }

          function reducer(ret, next) {
              var $this = $$$1(next);
              var existingData = $this.data('fuc-switch');
              var data = existingData || new BootstrapSwitch(next, option);
              if (!existingData) {
                  $this.data('fuc-switch', data);
              }
              if (typeof option === 'string') {
                  console.log(data);
                  return data[option].apply(data, args);
              }
              return ret;
          }
          return Array.prototype.reduce.call(this, reducer, this);
      };
      $$$1.fn.bootstrapSwitch.Constructor = BootstrapSwitch;
      $$$1.fn.bootstrapSwitch.defaults = {
          state: true,
          size: null,
          animate: true,
          disabled: false,
          readonly: false,
          indeterminate: false,
          inverse: false,
          radioAllOff: false,
          onColor: 'primary',
          offColor: 'default',
          onText: 'ON',
          offText: 'OFF',
          labelText: '&nbsp',
          handleWidth: 'auto',
          labelWidth: 'auto',
          baseClass: 'fuc-switch',
          wrapperClass: 'wrapper',
          isActive: 'isActive',
          onInit: function onInit() {},
          onSwitchChange: function onSwitchChange() {}
      };
  });
  });

  unwrapExports(_switch);

  var cssPrefix = 'fuc-';

  var Menu = function ($$$1) {
    $$$1(function () {
      var subMenuContainer = $$$1('.sub-menu-container');
      var rootLayout = $$$1('.fuc-t-fp');
      var mainMenu = $$$1('.main-menu-container');

      /*
       * 处理页面初始化状态
       */
      var activeMenuItem = mainMenu.find('.active');
      //展开默认选中菜单
      activeMenuItem.parents('.' + cssPrefix + 'menu-item').addClass('open');
      //滚动到选中位置
      var scroller = activeMenuItem.parents('.menu-wrapper');
      if (activeMenuItem.length > 0 && scroller.height() < activeMenuItem.offset().top) {
        scroller.scrollTop(activeMenuItem.offset().top - scroller.height());
      }

      //处理展开关闭逻辑
      $$$1('.main-menu-container,.sub-menu-container').on('click', '.' + cssPrefix + 'menu-item', function (e) {
        //最小化菜单走单独的逻辑
        if (rootLayout.hasClass('min-menu')) {
          return;
        }
        var $this = $$$1(this);
        if (!$this.hasClass('open')) {
          $this.parent().find('.open').removeClass('open');
          $this.addClass('open');
        } else {
          $this.removeClass('open');
        }
      });

      //处理子菜单问题
      mainMenu.on('click', '.' + cssPrefix + 'menu .' + cssPrefix + 'menu .' + cssPrefix + 'menu-item', function (e) {
        var $this = $$$1(this);
        var child = $this.children('ul');
        var level2Head = $this.children('.level2');

        if (level2Head.length > 0) {
          if (child.length > 0) {
            //改变整体布局
            rootLayout.addClass('sub-menu-in');
            //填充子菜单
            subMenuContainer.find('.title').text(level2Head.find('.title').text());
            subMenuContainer.find('.sub-menu-wrapper').html(child[0].outerHTML);

            //移除原有选中状态
            mainMenu.find('.' + cssPrefix + 'menu-item.active').removeClass('active');
            //为现有菜单添加选中状态
            $this.addClass('active');
          } else {
            rootLayout.removeClass('sub-menu-in');
          }
        }
      });
      //处理子菜单收回
      subMenuContainer.on('click', '.arrow', function (e) {
        //改变整体布局
        rootLayout.removeClass('sub-menu-in');
      });

      //处理菜单最小化
      $$$1('.menu-controller').on('click', function () {
        rootLayout.toggleClass('min-menu');
      });

      //处理最小菜单第一级菜单的点击事件
      var popupMenu2 = $$$1('.popup-menu');
      $$$1(document.body).on('click', '.' + cssPrefix + 'content,.' + cssPrefix + 'nav,.menu-controller', function () {
        popupMenu2.css({ opacity: 0 });
        setTimeout(function () {
          popupMenu2.css({ display: 'none' });
        }, 300);
      }).on('click', '.min-menu .main-menu-container .' + cssPrefix + 'menu-item', function (e) {
        var $this = $$$1(this);
        var subMenu = $this.children('.' + cssPrefix + 'menu');
        if (subMenu.length > 0) {
          popupMenu2.children('.title').text($this.children('.menu-title').attr('title'));
          popupMenu2.children('.content').html(subMenu[0].outerHTML);
          popupMenu2.css({ top: e.clientY - 40, left: e.clientX, opacity: 0, display: 'block' });
          setTimeout(function () {
            popupMenu2.css({ left: 74, opacity: 1 });
          }, 30);
        }
      }).on('focus', '.popup-menu .fuc-menu-item .menu-title', function (e) {
        //处理弹出子菜单hover事件

      });
    });
  }($);

  /*date-picker.js脚本不需打包，单独引用*/

  var doc = document;

  (function ($$$1) {
    if (typeof $$$1 === 'undefined') {
      throw new TypeError('Fuc.js\'s JavaScript requires jQuery. jQuery must be included before Fuc.js\'s JavaScript.');
    }

    // 解决低版本的 jquery 没有这个属性判断
    if ($$$1.support.transition === undefined) {
      $$$1.support.transition = function () {
        var $div = doc.createElement('div');
        $div.style.display = 'none';

        var domPrefixes = 'Webkit Moz O ms Khtml'.split(' ');
        if ($div.style.transition !== undefined) {
          return true;
        }

        for (var i = 0; i < domPrefixes.length; i++) {
          if ($div.style[domPrefixes[i] + 'Transition'] !== undefined) {
            return true;
          }
        }

        return false;
      }();
    }
  })($);

  exports.Forms = Form;
  exports.Input = Input;
  exports.Select = Select;
  exports.BackTop = BackTop;
  exports.Loading = loading;
  exports.Modal = Modal;
  exports.Upload = Upload;
  exports.Tooltip = Tooltip;
  exports.Popover = Popover;
  exports.Message = Message;
  exports.Slider = slider;
  exports.Menu = Menu;
  exports.Paging = Paging;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=fuc.js.map
